/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * 
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package carto;

import java.io.Serializable;
import java.util.Vector;

/**
 *
 * @author  Laurent Jégou
 */
public class AnalysePlages implements Serializable {

	public int nbreClasses;
    public int typeDiscret; //0 = Q, 1 = Equ, 2 = Moy, 3 = Std, 4 = Jk, 5 = M
    public String champ;
    public String titreLegende;
    public String sousTitreL;
    public Vector classes; //vector de ClassesDiscret
    public int champNum = -1;

    /** Creates a new instance of AnalysePlages */
    public AnalysePlages() {
        classes = new Vector(8);
    }

    public Object clone() {
        try {
            AnalysePlages ap2 = null;
            ap2 = (AnalysePlages) super.clone();
            return ap2;
        } catch (CloneNotSupportedException x) {
            return (new InternalError(Messages.getString("Carte.0"))); //$NON-NLS-1$
        }
    }

    public AnalysePlages copie() {
    	AnalysePlages ap2 = new AnalysePlages();
    	ap2.champ = this.champ;
    	ap2.champNum = this.champNum;
        int i = 0;
        for (i = 0; i < classes.size(); i++) {
        	ap2.classes.add(((ClasseDiscret) classes.elementAt(i)).copie());
        }
    	ap2.nbreClasses = this.nbreClasses;
    	ap2.sousTitreL = this.sousTitreL;
    	ap2.titreLegende = this.titreLegende;
    	ap2.typeDiscret = this.typeDiscret;
    	return ap2;
    }
    
    public void videClasses() {
        int i = 0;
        for (i = 0; i < classes.size(); i++) {
            //((ClasseDiscret) classes.elementAt(i)).couleur = java.awt.Color.white;
            ((ClasseDiscret) classes.elementAt(i)).limiteInf = 0;
            ((ClasseDiscret) classes.elementAt(i)).limiteSup = 0;
            ((ClasseDiscret) classes.elementAt(i)).nbreIndividus = 0;
            ((ClasseDiscret) classes.elementAt(i)).partIndividus = 0;
            ((ClasseDiscret) classes.elementAt(i)).titreLeg = ""; //$NON-NLS-1$
        }
    }

    public void setChampNum(int valeur) {
        this.champNum = valeur;
    }

    public int getChampNum() {
        return this.champNum;
    }
    
}