/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package carto;

import java.awt.Color;
import java.io.Serializable;
import java.util.BitSet;

/**
 *
 * @author  Laurent Jégou
 */
public class ClasseDiscret implements Cloneable, Serializable {
    
    public double limiteInf;
    public double limiteSup;
    public Color couleur;
    public int nbreIndividus;
    public float partIndividus;
    private BitSet typeHachure;
    private double chasse;
    private double grain;
    public String titreLeg;
    
    /** Creates a new instance of ClasseDiscret */
    public ClasseDiscret() {
        //nitchevo
    }
    
    /* Redéfinition de la méthode clone */
    public Object clone() {
        try {
            ClasseDiscret cl = (ClasseDiscret) super.clone();
            return cl;
        } catch (CloneNotSupportedException x) {
            return (new InternalError(Messages.getString("ClasseDiscret.0"))); //$NON-NLS-1$
        }
    }
    
    public ClasseDiscret copie() {
    	ClasseDiscret cl2 = new ClasseDiscret();
    	cl2.limiteInf = this.limiteInf;
    	cl2.limiteSup = this.limiteSup;
    	cl2.nbreIndividus = this.nbreIndividus;
    	cl2.partIndividus = this.partIndividus;
    	cl2.titreLeg = this.titreLeg;
    	cl2.couleur = this.couleur;
    	cl2.typeHachure = this.typeHachure;
    	cl2.chasse = this.chasse;
    	cl2.grain = this.grain;
    	return cl2;
    }
}
