/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.event.DocumentEvent;

import org.nfunk.jep.JEP;

import donnees.champDonnees;

public class BoiteDialogueCalcChamp extends JDialog implements ActionListener {

    public FenetrePrincipale fen;

    public Vector columnNames;

    public Vector tableau;

    public String calcul = ""; //$NON-NLS-1$

    public int calculint = 0;

    public int numcol = -1;

    public BoiteDialogueCalcChamp(FenetrePrincipale f, Vector c, Vector t) {
        super(f, Messages.getString("BoiteDialogueCalcChamp.1"), true); //$NON-NLS-1$
        this.fen = f;
        this.columnNames = c;
        this.tableau = t;
 
        initComponents();
    }

    private void initComponents() {
        pannelNom = new javax.swing.JPanel();
        pannelBouton = new javax.swing.JPanel();
        labelNouvChamp = new javax.swing.JLabel();
        jtNouvChamp = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        panneauChiffres = new javax.swing.JPanel();
        bUn = new javax.swing.JButton();
        bDeux = new javax.swing.JButton();
        bTrois = new javax.swing.JButton();
        bQuatre = new javax.swing.JButton();
        bCinq = new javax.swing.JButton();
        bSix = new javax.swing.JButton();
        bSept = new javax.swing.JButton();
        bHuit = new javax.swing.JButton();
        bNeuf = new javax.swing.JButton();
        bZero = new javax.swing.JButton();
        panneauCompo = new javax.swing.JPanel();
        labelChamp = new javax.swing.JLabel();
        panneauResultat = new javax.swing.JPanel();
        labelTexteResultat = new javax.swing.JLabel();
        labelResultat = new javax.swing.JLabel();

        int i = 0;
       
        cbChamp = new javax.swing.JComboBox();
        int compteur = 0;
        for (i = 0; i < columnNames.size(); i++) {
            int ti = ((champDonnees) columnNames.get(i)).typeI;
            if (ti == 0 || ti == 2) {
                compteur += 1;
                cbChamp.addItem(((champDonnees) columnNames.get(i)).nom);
            }
        }
        
        bPlus = new javax.swing.JButton();
        bMoins = new javax.swing.JButton();
        bFois = new javax.swing.JButton();
        bDiv = new javax.swing.JButton();
        bParentO = new javax.swing.JButton();
        bParentF = new javax.swing.JButton();
        bExp = new javax.swing.JButton();
        panneauFormule = new javax.swing.JPanel();
        jtFormule = new javax.swing.JTextField();
        bAnnuler = new javax.swing.JButton();
        bOK = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        pannelNom.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        labelNouvChamp.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        labelNouvChamp.setText(Messages.getString("BoiteDialogueCalcChamp.2")); //$NON-NLS-1$
        labelNouvChamp.setForeground(new java.awt.Color(0, 51, 51));
        labelNouvChamp.setBackground(new java.awt.Color(204, 204, 204));
        labelNouvChamp.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        labelNouvChamp.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        labelNouvChamp.setPreferredSize(new java.awt.Dimension(160, 20));
        labelNouvChamp.setOpaque(true);
        labelNouvChamp.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        labelNouvChamp.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        pannelNom.add(labelNouvChamp);

        jtNouvChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jtNouvChamp.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        jtNouvChamp.setPreferredSize(new java.awt.Dimension(200, 27));
        jtNouvChamp.setAutoscrolls(false);
        pannelNom.add(jtNouvChamp);

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        /**
         * *********PANNEAU
         * COMPOSANTS**********************************************************
         */

        panneauCompo.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueCalcChamp.5"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, //$NON-NLS-1$
                new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 51, 51))); //$NON-NLS-1$
        panneauCompo.setPreferredSize(new java.awt.Dimension(120, 140));

        labelChamp.setText(Messages.getString("BoiteDialogueCalcChamp.7")); //$NON-NLS-1$
        labelChamp.setForeground(new java.awt.Color(0, 51, 51));
        labelChamp.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
        labelChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        labelChamp.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        panneauCompo.add(labelChamp);

        cbChamp.setBackground(new java.awt.Color(255, 255, 255));
        cbChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        cbChamp.setPreferredSize(new java.awt.Dimension(90, 25));
        cbChamp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbChampActionPerformed(evt);
            }
        });
        panneauCompo.add(cbChamp);

        bPlus.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bPlus.setText(" + "); //$NON-NLS-1$
        bPlus.setPreferredSize(new java.awt.Dimension(20, 20));
        bPlus.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bPlus.setMinimumSize(new java.awt.Dimension(10, 10));
        bPlus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bPlusActionPerformed(evt);
            }
        });
        panneauCompo.add(bPlus);

        bMoins.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bMoins.setText("-"); //$NON-NLS-1$
        bMoins.setPreferredSize(new java.awt.Dimension(20, 20));
        bMoins.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bMoins.setMinimumSize(new java.awt.Dimension(10, 10));
        bMoins.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bMoinsActionPerformed(evt);
            }
        });
        panneauCompo.add(bMoins);

        bFois.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bFois.setText("*"); //$NON-NLS-1$
        bFois.setPreferredSize(new java.awt.Dimension(20, 20));
        bFois.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bFois.setMinimumSize(new java.awt.Dimension(10, 10));
        bFois.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bFoisActionPerformed(evt);
            }
        });
        panneauCompo.add(bFois);

        bDiv.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bDiv.setText("/"); //$NON-NLS-1$
        bDiv.setPreferredSize(new java.awt.Dimension(20, 20));
        bDiv.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bDiv.setMinimumSize(new java.awt.Dimension(10, 10));
        bDiv.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDivActionPerformed(evt);
            }
        });
        panneauCompo.add(bDiv);

        bParentO.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bParentO.setText("("); //$NON-NLS-1$
        bParentO.setPreferredSize(new java.awt.Dimension(20, 20));
        bParentO.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bParentO.setMinimumSize(new java.awt.Dimension(10, 10));
        bParentO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bParentOActionPerformed(evt);
            }
        });
        panneauCompo.add(bParentO);

        bParentF.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bParentF.setText(")"); //$NON-NLS-1$
        bParentF.setPreferredSize(new java.awt.Dimension(20, 20));
        bParentF.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bParentF.setMinimumSize(new java.awt.Dimension(10, 10));
        bParentF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bParentFActionPerformed(evt);
            }
        });
        panneauCompo.add(bParentF);

        bExp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bExp.setText("^"); //$NON-NLS-1$
        bExp.setPreferredSize(new java.awt.Dimension(20, 20));
        bExp.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bExp.setMinimumSize(new java.awt.Dimension(10, 10));
        bExp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bExpActionPerformed(evt);
            }
        });
        panneauCompo.add(bExp);

        jPanel1.add(panneauCompo);

        /**
         * *********PANNEAU
         * CHIFFRES**********************************************************
         */

        panneauChiffres.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panneauChiffres.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueCalcChamp.0"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, //$NON-NLS-1$
                new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 51, 51))); //$NON-NLS-1$
        panneauChiffres.setPreferredSize(new java.awt.Dimension(100, 140));

        bUn.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bUn.setText("1"); //$NON-NLS-1$
        bUn.setPreferredSize(new java.awt.Dimension(20, 20));
        bUn.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bUn.setMinimumSize(new java.awt.Dimension(10, 10));
        bUn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bUnActionPerformed(evt);
            }
        });
        panneauChiffres.add(bUn);

        bDeux.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bDeux.setText("2"); //$NON-NLS-1$
        bDeux.setPreferredSize(new java.awt.Dimension(20, 20));
        bDeux.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bDeux.setMinimumSize(new java.awt.Dimension(10, 10));
        bDeux.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDeuxActionPerformed(evt);
            }
        });
        panneauChiffres.add(bDeux);

        bTrois.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bTrois.setText("3"); //$NON-NLS-1$
        bTrois.setPreferredSize(new java.awt.Dimension(20, 20));
        bTrois.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bTrois.setMinimumSize(new java.awt.Dimension(10, 10));
        bTrois.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bTroisActionPerformed(evt);
            }
        });
        panneauChiffres.add(bTrois);

        bQuatre.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bQuatre.setText("4"); //$NON-NLS-1$
        bQuatre.setPreferredSize(new java.awt.Dimension(20, 20));
        bQuatre.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bQuatre.setMinimumSize(new java.awt.Dimension(10, 10));
        bQuatre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bQuatreActionPerformed(evt);
            }
        });
        panneauChiffres.add(bQuatre);

        bCinq.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bCinq.setText("5"); //$NON-NLS-1$
        bCinq.setPreferredSize(new java.awt.Dimension(20, 20));
        bCinq.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bCinq.setMinimumSize(new java.awt.Dimension(10, 10));
        bCinq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCinqActionPerformed(evt);
            }
        });
        panneauChiffres.add(bCinq);

        bSix.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bSix.setText("6"); //$NON-NLS-1$
        bSix.setPreferredSize(new java.awt.Dimension(20, 20));
        bSix.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bSix.setMinimumSize(new java.awt.Dimension(10, 10));
        bSix.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSixActionPerformed(evt);
            }
        });
        panneauChiffres.add(bSix);

        bSept.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bSept.setText("7"); //$NON-NLS-1$
        bSept.setPreferredSize(new java.awt.Dimension(20, 20));
        bSept.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bSept.setMinimumSize(new java.awt.Dimension(10, 10));
        bSept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSeptActionPerformed(evt);
            }
        });
        panneauChiffres.add(bSept);

        bHuit.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bHuit.setText("8"); //$NON-NLS-1$
        bHuit.setPreferredSize(new java.awt.Dimension(20, 20));
        bHuit.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bHuit.setMinimumSize(new java.awt.Dimension(10, 10));
        bHuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bHuitActionPerformed(evt);
            }
        });
        panneauChiffres.add(bHuit);

        bNeuf.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bNeuf.setText("9"); //$NON-NLS-1$
        bNeuf.setPreferredSize(new java.awt.Dimension(20, 20));
        bNeuf.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bNeuf.setMinimumSize(new java.awt.Dimension(10, 10));
        bNeuf.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bNeufActionPerformed(evt);
            }
        });
        panneauChiffres.add(bNeuf);

        bZero.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bZero.setText("0"); //$NON-NLS-1$
        bZero.setPreferredSize(new java.awt.Dimension(20, 20));
        bZero.setMargin(new java.awt.Insets(0, 0, 0, 0));
        bZero.setMinimumSize(new java.awt.Dimension(10, 10));
        bZero.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bZeroActionPerformed(evt);
            }
        });
        panneauChiffres.add(bZero);

        jPanel1.add(panneauChiffres);

        panneauFormule.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panneauFormule.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueCalcChamp.46"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, //$NON-NLS-1$
                new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 51, 51))); //$NON-NLS-1$
        panneauFormule.setPreferredSize(new java.awt.Dimension(160, 140));
        panneauFormule.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$

        jtFormule.setPreferredSize(new java.awt.Dimension(140, 90));
        jtFormule.setLocation(0, 0);
        jtFormule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               jtFormuleActionPerformed(evt);
            }

			private void jtFormuleActionPerformed(ActionEvent evt) {
				evalueFormule();			
			}
        });
        jtFormule.getDocument().addDocumentListener(new javax.swing.event.DocumentListener() {
        	public void changedUpdate(DocumentEvent e) {
        		
        	}

			public void insertUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				evalueFormule();
			}

			public void removeUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				evalueFormule();
			}
        });
        panneauFormule.add(jtFormule);

        jPanel1.add(panneauFormule);

        panneauResultat.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
              
        labelTexteResultat.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        labelTexteResultat.setPreferredSize(new java.awt.Dimension(100, 27));
        labelTexteResultat.setText(Messages.getString("BoiteDialogueCalcChamp.120")); //$NON-NLS-1$
        labelTexteResultat.setForeground(new java.awt.Color(0, 51, 51));
        labelTexteResultat.setBackground(new java.awt.Color(204, 204, 204));
        labelTexteResultat.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        labelTexteResultat.setPreferredSize(new java.awt.Dimension(160, 20));
        labelTexteResultat.setOpaque(true);
        labelTexteResultat.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        labelTexteResultat.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        
        panneauResultat.add(labelTexteResultat);
        
        labelResultat.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        labelResultat.setPreferredSize(new java.awt.Dimension(200, 27));
        labelResultat.setLocation(120,27);
        labelResultat.setBorder(new javax.swing.border.EtchedBorder());
        labelResultat.setBackground(new Color(255,255,255));
        labelResultat.setText("coucou");
        
        panneauResultat.add(labelResultat);
        
        pannelBouton.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER));
        
       
        bAnnuler.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bAnnuler.setPreferredSize(new java.awt.Dimension(100, 27));
        bAnnuler.setText(Messages.getString("BoiteDialogueCalcChamp.50")); //$NON-NLS-1$
        bAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bAnnulerActionPerformed(evt);
            }
        });
        pannelBouton.add(bAnnuler);

        bOK.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bOK.setText(Messages.getString("BoiteDialogueCalcChamp.52")); //$NON-NLS-1$
        bOK.setPreferredSize(new java.awt.Dimension(100, 27));
        bOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOKActionPerformed(evt);
            }
        });
        pannelBouton.add(bOK);
        
        getContentPane().add(pannelNom);
        
        getContentPane().add(jPanel1);
        
        getContentPane().add(panneauResultat); 
        
        getContentPane().add(pannelBouton);
        
        pack();
    }

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }

    /**
     * De INT vers String
     */
    public static String intToStr(int i) {
        String texte = new String();
        texte = String.valueOf(i);
        return texte;
    }

    private void cbChampActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        String var = cbChamp.getSelectedItem().toString(); //recupere le champ
        // selectionné
        // servant é calculer
        // le nouv champ
        this.jtFormule.setText(form + cbChamp.getSelectedItem()); //rajoute ce
        // champ dans
        // la formule
        evalueFormule();
    }

    private void bUnActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "1"); //$NON-NLS-1$
        calcul = calcul + "1"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bDeuxActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "2"); //$NON-NLS-1$
        calcul = calcul + "2"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bTroisActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "3"); //$NON-NLS-1$
        calcul = calcul + "3"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bQuatreActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "4"); //$NON-NLS-1$
        calcul = calcul + "4"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bCinqActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "5"); //$NON-NLS-1$
        calcul = calcul + "5"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bSixActionPerformed(java.awt.event.ActionEvent evt) {
        String form = "";         //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "6"); //$NON-NLS-1$
        calcul = calcul + "6"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bSeptActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "7"); //$NON-NLS-1$
        calcul = calcul + "7"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bHuitActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "8"); //$NON-NLS-1$
        calcul = calcul + "8"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bNeufActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "9"); //$NON-NLS-1$
        calcul = calcul + "9"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bZeroActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "0"); //$NON-NLS-1$
        calcul = calcul + "0"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bPlusActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + " + "); //$NON-NLS-1$
        calcul = calcul + "+"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bMoinsActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "-"); //$NON-NLS-1$
        calcul = calcul + "-"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bFoisActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "*"); //$NON-NLS-1$
        calcul = calcul + "*"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bDivActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "/"); //$NON-NLS-1$
        calcul = calcul + "/"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bParentOActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "("); //$NON-NLS-1$
        calcul = calcul + "("; //$NON-NLS-1$
        evalueFormule();
    }

    private void bParentFActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + ")"); //$NON-NLS-1$
        calcul = calcul + ")"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bExpActionPerformed(java.awt.event.ActionEvent evt) {
        String form = ""; //$NON-NLS-1$
        form = this.jtFormule.getText();
        this.jtFormule.setText(form + "^"); //$NON-NLS-1$
        calcul = calcul + "^"; //$NON-NLS-1$
        evalueFormule();
    }

    private void bAnnulerActionPerformed(java.awt.event.ActionEvent evt) {
        setVisible(false);
        dispose();
    }

    public boolean isNombre(String chaine) {
        boolean rep = true;
        int i = 0, j = 1;
        while ((rep == true) && (i < chaine.length())) {
            String lett = chaine.substring(i, j);
            j++;
            i++;

            if ((lett.compareTo("1") == 0) || (lett.compareTo("2") == 0) || (lett.compareTo("3") == 0) || (lett.compareTo("4") == 0) || (lett.compareTo("5") == 0) || (lett.compareTo("6") == 0) || (lett //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
                    .compareTo(Messages.getString("BoiteDialogueCalcChamp.111")) == 0) || (lett.compareTo("8") == 0) || (lett.compareTo("9") == 0) || (lett.compareTo("0") == 0) || (lett.compareTo(" ") == 0) || (lett.compareTo(".") == 0)) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
                rep = true;
            else
                rep = false;
        }
        return rep;
    }

    public void afficherBoiteDialogue() {
        this.setLocationRelativeTo(fen);
        this.setVisible(true);
    }

    public void bOKActionPerformed(java.awt.event.ActionEvent evt) {
        this.setCursor(new Cursor(3));
        String champ = jtNouvChamp.getText();
        String formule = jtFormule.getText();
        boolean existeDeja = false;
        int i = 0;

        if (labelResultat.getText().equals("NaN")) {
        	JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueCalcChamp.121"));
        	this.setCursor(new Cursor(0));
        } else {
        	for (i = 0; i < columnNames.size(); i++) {
        		if (champ.compareTo(((champDonnees) columnNames.get(i)).nom) == 0)
        			existeDeja = true;
        	}
        	// controle des champs é saisir
        	if (champ.compareTo("") == 0) { //$NON-NLS-1$
        		JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueCalcChamp.118")); //$NON-NLS-1$
        	} else {
        		if (existeDeja == true)
        			JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueCalcChamp.119")); //$NON-NLS-1$
        		else {
        			fen.afficherTableCalculerCol(champ, formule);
        			setVisible(false);
        			dispose();
        		}
        	}
        	this.setCursor(new Cursor(0));
        }
    }
        
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
    
    }
    
    private void evalueFormule() {
    	Integer i = 0;
		JEP myParser = new JEP();
		String formuleBase = jtFormule.getText();
		String formuleVa = formuleBase;
		for (i = 0; i < columnNames.size(); i++) {
			String nomChamp = ((champDonnees) columnNames.get(i)).nom;
			if (formuleVa.lastIndexOf(nomChamp) != -1) {
				String valeur = getValueAt(0, i).toString();
				String tf = formuleVa.replaceAll(nomChamp, valeur);
				formuleVa = tf;
			}
		}
		myParser.parseExpression(formuleVa);
		labelResultat.setText(String.valueOf(myParser.getValue()));
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        return tableau.elementAt((rowIndex * columnNames.size()) + columnIndex);
    }
    
    // Variables declaration - do not modify
    private javax.swing.JPanel panneauFormule;

    private javax.swing.JPanel pannelBouton;

    public javax.swing.JButton bMoins;

    public javax.swing.JButton bNeuf;

    public javax.swing.JButton bQuatre;

    public javax.swing.JButton bParentF;

    private javax.swing.JPanel panneauChiffres;

    public javax.swing.JButton bDiv;

    public javax.swing.JButton bCinq;

    public javax.swing.JTextField jtFormule;

    public javax.swing.JComboBox cbChamp;

    public javax.swing.JButton bTrois;

    private javax.swing.JPanel pannelNom;

    public javax.swing.JButton bUn;

    private javax.swing.JLabel labelNouvChamp;

    public javax.swing.JButton bFois;

    public javax.swing.JButton bPlus;

    public javax.swing.JButton bHuit;

    private javax.swing.JPanel panneauCompo;

    public javax.swing.JTextField jtNouvChamp;

    public javax.swing.JButton bSept;

    private javax.swing.JButton bAnnuler;

    public javax.swing.JButton bExp;

    private javax.swing.JLabel labelChamp;

    private javax.swing.JPanel jPanel1;

    public javax.swing.JButton bSix;

    public javax.swing.JButton bZero;

    public javax.swing.JButton bDeux;

    public javax.swing.JButton bParentO;

    private javax.swing.JButton bOK;
    
    private javax.swing.JPanel panneauResultat;
    
    private javax.swing.JLabel labelTexteResultat;
    
    private javax.swing.JLabel labelResultat;

    // End of variables declaration

}