/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Cursor;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import donnees.champDonnees;

public class BoiteDialogueCentreReduireChamp extends javax.swing.JDialog implements ActionListener {

    public Vector columnNames;

    public Vector tableau;

    public Vector columnNamesQuanti = new Vector();

    public FenetrePrincipale fen;

    public BoiteDialogueCentreReduireChamp(FenetrePrincipale f, Vector c, Vector t) {
        super(f, Messages.getString("BoiteDialogueCentreReduireChamp.0"), true); //$NON-NLS-1$
        this.fen = f;
        this.columnNames = c;
        this.tableau = t;
        int i = 0;
        boolean test = false;

        for (i = 0; i < columnNames.size(); i++) {
            int ti = ((champDonnees) columnNames.get(i)).typeI;
            if (ti == 0 || ti == 2) {
                columnNamesQuanti.add(((champDonnees) columnNames.get(i)).nom);
            }
        }
        cbChamp = new JComboBox(columnNamesQuanti);
        pannelCombo = new javax.swing.JPanel();
        pannelNom = new javax.swing.JPanel();
        labelNouvChamp = new javax.swing.JLabel();
        jtNouvChamp = new javax.swing.JTextField();
        jLabelCombo = new javax.swing.JLabel();
        bok = new javax.swing.JButton();
        jPanelBouton = new JPanel();
        bcancel = new javax.swing.JButton();
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabelCombo.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabelCombo.setText(Messages.getString("BoiteDialogueCentreReduireChamp.1")); //$NON-NLS-1$
        jLabelCombo.setForeground(new java.awt.Color(0, 51, 51));
        jLabelCombo.setBackground(new java.awt.Color(204, 204, 204));
        jLabelCombo.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelCombo.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        jLabelCombo.setPreferredSize(new java.awt.Dimension(230, 20));
        jLabelCombo.setMinimumSize(new java.awt.Dimension(0, 15));
        jLabelCombo.setMaximumSize(new java.awt.Dimension(50, 15));
        jLabelCombo.setOpaque(true);
        jLabelCombo.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        jLabelCombo.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);

        pannelCombo.add(jLabelCombo);
        pannelNom.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        labelNouvChamp.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        labelNouvChamp.setText(Messages.getString("BoiteDialogueCentreReduireChamp.3")); //$NON-NLS-1$
        labelNouvChamp.setForeground(new java.awt.Color(0, 51, 51));
        labelNouvChamp.setBackground(new java.awt.Color(204, 204, 204));
        labelNouvChamp.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        labelNouvChamp.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        labelNouvChamp.setPreferredSize(new java.awt.Dimension(160, 20));
        labelNouvChamp.setMinimumSize(new java.awt.Dimension(0, 15));
        labelNouvChamp.setMaximumSize(new java.awt.Dimension(50, 15));
        labelNouvChamp.setOpaque(true);
        labelNouvChamp.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        labelNouvChamp.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        pannelNom.add(labelNouvChamp);

        jtNouvChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jtNouvChamp.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        jtNouvChamp.setPreferredSize(new java.awt.Dimension(90, 30));
        jtNouvChamp.setAutoscrolls(false);
        pannelNom.add(jtNouvChamp);

        cbChamp.setMaximumRowCount(20);
        cbChamp.setBackground(new java.awt.Color(255, 255, 255));
        cbChamp.setPreferredSize(new java.awt.Dimension(230, 22));
        pannelCombo.add(cbChamp);

        bok.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bok.setText(Messages.getString("BoiteDialogueCentreReduireChamp.7")); //$NON-NLS-1$
        bok.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanelBouton.add(bok);
        bok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bokActionPerformed(evt);
            }
        });

        bcancel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bcancel.setText(Messages.getString("BoiteDialogueCentreReduireChamp.9")); //$NON-NLS-1$
        bcancel.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanelBouton.add(bcancel);
        bcancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bcancelActionPerformed(evt);
            }
        });
        getContentPane().add(jPanelBouton, java.awt.BorderLayout.SOUTH);
        getContentPane().add(pannelNom, java.awt.BorderLayout.NORTH);
        getContentPane().add(pannelCombo, java.awt.BorderLayout.CENTER);
        pack();
    }

    /** Closes the dialog */
    public void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }

    public void afficherBoiteDialogue() {
        this.setLocationRelativeTo(fen);
        this.setVisible(true);
    }

    public void bokActionPerformed(java.awt.event.ActionEvent evt) {
        this.setCursor(new Cursor(3));
        String chpAcreer = jtNouvChamp.getText();
        if (chpAcreer.compareTo("") == 0) { // controle des champs é saisir //$NON-NLS-1$
            JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueCentreReduireChamp.11")); //$NON-NLS-1$
        } else {
            if (columnNamesQuanti.size() == 0) {
                JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueCentreReduireChamp.12")); //$NON-NLS-1$
            } else {
                String champ = cbChamp.getSelectedItem().toString();
                fen.afficherTableCentrerReduireCol(champ, chpAcreer);
                setVisible(false);
                dispose();
                this.setCursor(new Cursor(0));
            }
        }
    }

    public void bcancelActionPerformed(java.awt.event.ActionEvent evt) {
        setVisible(false);
        dispose();
    }

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {

    }

    private javax.swing.JTextField jtNouvChamp;

    private javax.swing.JLabel labelNouvChamp;

    private javax.swing.JPanel pannelNom;

    private javax.swing.JPanel pannelCombo;

    private javax.swing.JButton bok;

    private javax.swing.JButton bcancel;

    private JPanel jPanelBouton;

    private javax.swing.JLabel jLabelCombo;

    private javax.swing.JComboBox cbChamp;

    private javax.swing.JTable table;

}