/*
 * 28 aoét 2005 - 10h30
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie - version Java
 * Version beta 0.9
 *
 * Copyright 1997-2005 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright (c) 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (c) 2001 Andrew Khan (jxl import/export format Excelé)
 * 				Copyright (c) 2004 Anil Kumar K, anil@linuxense.com (javaDBF)
 * http://www.univ-tlse2.fr/geoprdc/scap
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;

import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;

import com.linuxense.javadbf.DBFField;
import com.linuxense.javadbf.DBFReader;

import jxl.CellType;
import jxl.Sheet;
import jxl.Workbook;
import jxl.biff.EmptyCell;
import jxl.read.biff.BiffException;
import donnees.champDonnees;

/*
 * @author Laurent
 *  
 */
public class BoiteDialogueImportXLS extends JDialog {

    private String fichierDonnees;

    public Vector champs;

    public Vector data;

    public Vector newChamps = new Vector(2);

    public Vector newData = new Vector(2);

    private String[] colonnes;

    private FenetrePrincipale base;

    public BoiteDialogueImportXLS(FenetrePrincipale parent, boolean modal, String titre, Vector champs, Vector data, String fichier) {
        super(parent, titre, modal);
        this.base = parent;
        this.fichierDonnees = fichier;
        this.champs = champs;
        this.data = data;

        lectureFichier();
        initComponents();
    }

    private void initComponents() {
        jbOk = new javax.swing.JButton();
        jbAnnuler = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jcGeocode = new javax.swing.JComboBox(colonnes);
        jPanel2 = new javax.swing.JPanel();
        jliColonnes = new javax.swing.JList(createData(colonnes));
        JScrollPane jlicScrollpane = new JScrollPane(jliColonnes);
        jlInfo = new javax.swing.JLabel();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        jbOk.setText(Messages.getString("BoiteDialogueImportXLS.0")); //$NON-NLS-1$
        jbOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbOkActionPerformed(evt);
            }
        });
        getContentPane().add(jbOk, new org.netbeans.lib.awtextra.AbsoluteConstraints(342, 258, -1, -1));

        jbAnnuler.setText(Messages.getString("BoiteDialogueImportXLS.1")); //$NON-NLS-1$
        jbAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbAnnulerActionPerformed(evt);
            }
        });
        getContentPane().add(jbAnnuler, new org.netbeans.lib.awtextra.AbsoluteConstraints(264, 258, -1, -1));

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueImportXLS.2"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jPanel1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jcGeocode.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jcGeocode.setSelectedIndex(0);
        jPanel1.add(jcGeocode, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 6, 390, -1));

        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel2.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueImportXLS.6"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jPanel2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jliColonnes.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jliColonnes.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jliColonnes.setSelectedIndex(1);
        jliColonnes.setCellRenderer(new CheckListRenderer());
        jliColonnes.setBorder(new EmptyBorder(0, 4, 0, 0));
        jliColonnes.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                int index = jliColonnes.locationToIndex(e.getPoint());
                CheckableItem item = (CheckableItem) jliColonnes.getModel().getElementAt(index);
                item.setSelected(!item.isSelected());
                Rectangle rect = jliColonnes.getCellBounds(index, index);
                jliColonnes.repaint(rect);
            }
        });
        jPanel2.add(jlicScrollpane, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 36, 378, 132));

        jlInfo.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jlInfo.setText(Messages.getString("BoiteDialogueImportXLS.11")); //$NON-NLS-1$
        jPanel2.add(jlInfo, new org.netbeans.lib.awtextra.AbsoluteConstraints(18, 18, 348, -1));

        getContentPane().add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 66, 390, 180));

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width - 410) / 2, (screenSize.height - 330) / 2, 410, 330);
    }

    private void jbOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        importation();
        this.base.newC = newChamps;
        this.base.newT = newData;
        setVisible(false);
        dispose();
    }

    private void jbAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        setVisible(false);
        dispose();
    }

    private void lectureFichier() {
        try {
            int i = 0;
            if (fichierDonnees.endsWith("xls")) {
	            Workbook workbook = Workbook.getWorkbook(new File(fichierDonnees));
	            Sheet sheet = workbook.getSheet(0);
	            int nbCols = sheet.getColumns();
	            colonnes = new String[nbCols];
	            for (i = 0; i < nbCols; i++) {
	                colonnes[i] = (sheet.getCell(i, 0).getContents());
	            }
	            workbook.close();
            }
            if (fichierDonnees.endsWith("dbf")) {
                InputStream inputStream  = new FileInputStream(fichierDonnees); // take dbf file as program argument
                DBFReader reader = new DBFReader(inputStream); 

                int nbCols = reader.getFieldCount();
                colonnes = new String[nbCols];
                for(i = 0; i < nbCols; i++) {
                    DBFField field = reader.getField( i);
                    colonnes[i] = field.getName();
                  }
                inputStream.close();
            }
        } catch (IOException ioe) {
            ioe.printStackTrace();
        } catch (BiffException e) {
            e.printStackTrace();
        }
    }

    private void importation() {
        int i = 0;
        int j = 0;
        int colGeocode = jcGeocode.getSelectedIndex();
        //int[] cols = jliColonnes.getSelectedIndices();
        Vector champsSel = new Vector(1);
        ListModel model = jliColonnes.getModel();
        int n = model.getSize();
        int[] cols = new int[n];
        int nb = 0;
        for (i = 0; i < n; i++) {
            CheckableItem item = (CheckableItem) model.getElementAt(i);
            if (item.isSelected()) {
                champsSel.add(new Integer(i));
                cols[nb] = i;
                nb += 1;
            }
        }
        try {
        	if (fichierDonnees.endsWith("xls")) {
	            Workbook workbook = Workbook.getWorkbook(new File(fichierDonnees));
	            Sheet sheet = workbook.getSheet(0);
	            int nbCols = sheet.getColumns();
	            int nbRows = sheet.getRows();
	            String geocode;
	            //Creation nouveaux champs
	            for (i = 0; i < nb; i++) {
	                champDonnees ncd = new champDonnees();
	                ncd.nom = sheet.getCell(cols[i], 0).getContents();
	                String cl = sheet.getCell(cols[i], 1).getContents();
	                CellType typeCellule = sheet.getCell(cols[i], 1).getType();
	                if (typeCellule == CellType.NUMBER || typeCellule == CellType.NUMBER_FORMULA) {
	                    ncd.typeI = 2;
	                    ncd.typeS = ncd.getTypeFromInt(2);
	                } else {
	                    ncd.typeI = 1;
	                    ncd.typeS = ncd.getTypeFromInt(1);
	                }
	                newChamps.add(ncd);
	            }
	            //Remplissage geocodes et creation nouvelles données
	            for (i = 1; i < nbRows; i++) {
	                geocode = sheet.getCell(colGeocode, i).getContents();
	                newData.add(geocode);
	                for (j = 0; j < nb; j++) {
	                    //sv = sv.replace(',', '.'); //$NON-NLS-1$ //$NON-NLS-2$
	                    switch (((champDonnees) newChamps.elementAt(j)).typeI) {
	                    case 1:
	                        String sv = sheet.getCell(cols[j], i).getContents();
	                        newData.add(new String(sv));
	                        break;
	                    case 2:
	                    	if ((sheet.getCell(cols[j], i)).getClass() != EmptyCell.class) {
	                    		double valeur = ((jxl.NumberCell)sheet.getCell(cols[j], i)).getValue();
	                    		newData.add(new Double(valeur));
	                    	} else {
	                    		newData.add(null);
	                    	}                        
	                    }
	                }
	            }
	            workbook.close();
        	}
        	if (fichierDonnees.endsWith("dbf")) {
                InputStream inputStream  = new FileInputStream(fichierDonnees); // take dbf file as program argument
                DBFReader reader = new DBFReader(inputStream); 

	            int nbCols = reader.getFieldCount();
	            int nbRows = reader.getRecordCount();
	            String geocode;
	            //Creation nouveaux champs
	            for (i = 0; i < nb; i++) {
	                champDonnees ncd = new champDonnees();
	                ncd.nom = reader.getField(cols[i]).getName();
	                if (reader.getField(cols[i]).getDataType() == DBFField.FIELD_TYPE_F || reader.getField(cols[i]).getDataType() == DBFField.FIELD_TYPE_N) {
	                    ncd.typeI = 2;
	                    ncd.typeS = ncd.getTypeFromInt(2);
	                } else {
	                    ncd.typeI = 1;
	                    ncd.typeS = ncd.getTypeFromInt(1);
	                }
	                newChamps.add(ncd);
	            }
	            //Remplissage geocodes et creation nouvelles données
            	Object[] rowO;
	            for (i = 1; i < nbRows; i++) {
	            	rowO = reader.nextRecord();
	                geocode = (String) rowO[colGeocode];
	                newData.add(geocode);
	                for (j = 0; j < nb; j++) {
	                    switch (((champDonnees) newChamps.elementAt(j)).typeI) {
	                    case 1:
	                        String sv = (String) rowO[cols[j]];
	                        newData.add(new String(sv));
	                        break;
	                    case 2:
	                    	if (rowO[cols[j]] != null) {
	                    		double valeur = ((Double)(rowO[cols[j]])).doubleValue();
	                    		newData.add(new Double(valeur));
	                    	} else {
	                    		newData.add(null);
	                    	}                        
	                    }
	                }
	            }
	            inputStream.close();
        	}
        } catch (IOException ioe) {
            ioe.printStackTrace();
        } catch (BiffException e) {
            e.printStackTrace();
        }
    }

    private CheckableItem[] createData(String[] strs) {
        int n = strs.length;
        CheckableItem[] items = new CheckableItem[n];
        for (int i = 0; i < n; i++) {
            items[i] = new CheckableItem(strs[i]);
        }
        return items;
    }

    class CheckableItem {
        private String str;

        private boolean isSelected;

        public CheckableItem(String str) {
            this.str = str;
            isSelected = false;
        }

        public void setSelected(boolean b) {
            isSelected = b;
        }

        public boolean isSelected() {
            return isSelected;
        }

        public String toString() {
            return str;
        }
    }

    class CheckListRenderer extends JCheckBox implements ListCellRenderer {

        public CheckListRenderer() {
            setBackground(UIManager.getColor("List.textBackground")); //$NON-NLS-1$
            setForeground(UIManager.getColor("List.textForeground")); //$NON-NLS-1$
        }

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean hasFocus) {
            setEnabled(list.isEnabled());
            setSelected(((CheckableItem) value).isSelected());
            setFont(list.getFont());
            setText(value.toString());
            return this;
        }
    }

    // Variables declaration - do not modify
    private javax.swing.JPanel jPanel1;

    private javax.swing.JPanel jPanel2;

    private javax.swing.JButton jbAnnuler;

    private javax.swing.JButton jbOk;

    private javax.swing.JComboBox jcGeocode;

    private javax.swing.JLabel jlInfo;

    private javax.swing.JList jliColonnes;
    // End of variables declaration

}

