/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import donnees.champDonnees;

public class BoiteDialogueSupprChamp extends JDialog implements ActionListener {

    public FenetrePrincipale fen;

    public Vector tableau;

    public Vector columnNames;

    /** Creates a new instance of BoiteDialogueSupprChamp */
    public BoiteDialogueSupprChamp(FenetrePrincipale f, Vector t, Vector c) {
        super(f, Messages.getString("BoiteDialogueSupprChamp.0"), true); //$NON-NLS-1$

        int i = 0;
        this.fen = f;
        this.columnNames = c;
        this.tableau = t;
        jLabel = new JLabel();
        jPanel = new JPanel();
        bok = new javax.swing.JButton();
        bcancel = new javax.swing.JButton();
        jComboBox = new javax.swing.JComboBox();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel.setText(Messages.getString("BoiteDialogueSupprChamp.1")); //$NON-NLS-1$
        jLabel.setForeground(new java.awt.Color(0, 51, 51));
        jLabel.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        getContentPane().add(jLabel, java.awt.BorderLayout.NORTH);

        bcancel.setText(Messages.getString("BoiteDialogueSupprChamp.3")); //$NON-NLS-1$
        bcancel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bcancel.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanel.add(bcancel);

        bok.setText(Messages.getString("BoiteDialogueSupprChamp.5")); //$NON-NLS-1$
        bok.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bok.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanel.add(bok);

        getContentPane().add(jPanel, java.awt.BorderLayout.SOUTH);

        //jComboBox.setMaximumRowCount(20);
        //jComboBox.setBackground(new java.awt.Color(255, 255, 255));
        jComboBox.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        jComboBox.setPreferredSize(new java.awt.Dimension(300, 22));
        for (i = 0; i < columnNames.size(); i++) {
            jComboBox.addItem(((champDonnees)columnNames.get(i)).nom);
        }
        getContentPane().add(jComboBox, java.awt.BorderLayout.CENTER);

        pack();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        bok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bokActionPerformed(evt);
            }
        });

        bcancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setVisible(false);
                dispose();
            }
        });
    }

    /** Closes the dialog */
    public void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }

    public void bokActionPerformed(java.awt.event.ActionEvent evt) {
        //String champ = jComboBox.getSelectedItem().toString();        fen.afficherTableSupprCol(champ);
        int champ = jComboBox.getSelectedIndex();
        fen.afficherTableSupprCol(champ);
        setVisible(false);
        dispose();
    }

    public void afficherBoiteDialogue() {
        if (columnNames.size() < 2) {
            JOptionPane.showMessageDialog(fen, Messages.getString("BoiteDialogueSupprChamp.8")); //$NON-NLS-1$
        } else {            
            this.setLocationRelativeTo(fen);
            this.setVisible(true);
        }
    }

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        
    }   

    // Variables declaration - do not modify
    private javax.swing.JButton bok;

    private javax.swing.JButton bcancel;

    private javax.swing.JLabel jLabel;

    private javax.swing.JComboBox jComboBox;

    private JPanel jPanel;

    // End of variables declaration

}