/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.awt.print.PageFormat;
import java.awt.print.PrinterJob;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.KeyStroke;

import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfWriter;

/**
 * @author Laurent
 *  
 */

public class FenetreMiseEnPage extends JInternalFrame {

    protected static ImageIcon createImageIcon(String path, String description) {
        java.net.URL imgURL = BarreOutil.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL, description);
        } else {
            System.err.println(Messages.getString("FenetreMiseEnPage.42") + path); //$NON-NLS-1$
            return null;
        }
    }

    public FenetreMilieu base;

    private int coordX;

    private int coordY;

    ActionListener DSOListener = new ActionListener() {
        public void actionPerformed(ActionEvent actionEvent) {
            surface.deleteSelectedObject();
        }
    };

    private JFrame fp;

    private JButton jbCa;

    private JButton jbEff;

    private JButton jbEtiq;

    private JButton jbFonte;

    private JButton jbLe;

    private JButton jbPDF;
    
    private JButton jbEch;

    private JButton jbPNG;
    
    private JButton jbNord;

    private JButton jbRect;
    
    private JButton jbTx;

    private JButton jbZM;

    private JButton jbZP;

    public JSeparator jSeparator1;

    public JSeparator jSeparator11;

    public JSeparator jSeparator12;

    public JSeparator jSeparator2;

    private String modeSouris = ""; //$NON-NLS-1$

    private DesignSurface surface;

    private double zoomOrigine = 0;

    public FenetreMiseEnPage(FenetreMilieu base, JFrame fp) {
        super(Messages.getString("FenetreMiseEnPage.1"), true, true, true, true); //$NON-NLS-1$
        this.base = base;
        this.fp = fp;
        initComponents();
        //KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0);
        //this.getInputMap().put(ks, "check");
        //this.getActionMap().put("check", new AbstractAction() {
        //    public void actionPerformed(ActionEvent e) {
        //        surface.deleteSelectedObject();
        //    }
        //});
    }
    
    public void ajoutEchelle() {
        String echelle = (String) JOptionPane.showInputDialog(this.base, null, Messages.getString("FenetreMiseEnPage.45"), JOptionPane.QUESTION_MESSAGE);
        if (echelle == null || echelle.equals("")) //$NON-NLS-1$
            return;
        surface.setAEchelle(Double.parseDouble(echelle));
    }

    public void ajoutEtiquette() {
        surface.setSouris("Etiquette"); //$NON-NLS-1$
        surface.setSelectedObject(null);
        surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }

    public void ajoutRectangle() {
        surface.setSouris("RectangleDebut"); //$NON-NLS-1$
        surface.setSelectedObject(null);
        surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }

    public void ajoutTexte() {
        String newTexte = (String) JOptionPane.showInputDialog(this.base, new FontChooser(this.fp, this.surface, surface.getAFonte()), Messages.getString("FenetreMiseEnPage.43"), //$NON-NLS-1$
                JOptionPane.QUESTION_MESSAGE);
        if (newTexte == null || newTexte.equals("")) //$NON-NLS-1$
            return;
        surface.setATexte(newTexte);
        surface.setSouris("TexteDebut"); //$NON-NLS-1$
        surface.setSelectedObject(null);
        surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }

    protected JRootPane createRootPane() {
        KeyStroke touche = KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0);
        JRootPane rootPane = new JRootPane();
        rootPane.registerKeyboardAction(DSOListener, touche, JComponent.WHEN_IN_FOCUSED_WINDOW);
        return rootPane;
    }
    
    public void exportJPEG() {
        //Selection fichier é créer
        JFileChooser expJPEG = new JFileChooser();
        ExampleFileFilter JPEGFilter = new ExampleFileFilter("JPEG"); //$NON-NLS-1$
        expJPEG.setFileFilter(JPEGFilter);
        expJPEG.showSaveDialog(this);
        String fichierJPEG = expJPEG.getSelectedFile().getPath();
        if (fichierJPEG.equals("")) //$NON-NLS-1$
            return;
        if (fichierJPEG.substring(fichierJPEG.length() - 4).toLowerCase().compareTo(".JPEG") != 0) { //$NON-NLS-1$
            fichierJPEG += ".jpeg"; //$NON-NLS-1$
        }
        //Génération fichier
        try {
            File fichier = new File("C:\\test.jpeg"); //$NON-NLS-1$
            BufferedImage mImage;
            mImage = new BufferedImage(surface.getSurfaceBounds().width, surface.getSurfaceBounds().height, BufferedImage.TYPE_INT_RGB);
            double aZoom = surface.getZoom();
            surface.setZoom(1);
            Graphics2D g2 = mImage.createGraphics();
            surface.setExpPDF(true);
            g2.setBackground(Color.white);
            surface.paintComponent(g2);
            ImageIO.write(mImage, "jpeg", fichier); //$NON-NLS-1$
            surface.setExpPDF(false);
            surface.setZoom(aZoom);
        } catch (IOException ioe) {
            System.err.println(ioe.getMessage());
        }
    }

    public void exportPDF() {
        //Selection fichier é créer
        JFileChooser expPDF = new JFileChooser();
        ExampleFileFilter PDFFilter = new ExampleFileFilter("pdf"); //$NON-NLS-1$
        expPDF.setFileFilter(PDFFilter);
        expPDF.showSaveDialog(this);
        if (expPDF.getSelectedFile().getPath() == null)
            return;
        String fichierPDF = expPDF.getSelectedFile().getPath();
        if (fichierPDF.equals("")) //$NON-NLS-1$
            return;
        if (fichierPDF.substring(fichierPDF.length() - 4).toLowerCase().compareTo(".pdf") != 0) { //$NON-NLS-1$
            fichierPDF += ".pdf"; //$NON-NLS-1$
        }
        //Génération fichier
        Document document = new Document();
        try {
            PdfWriter writer = PdfWriter.getInstance(document, new FileOutputStream(fichierPDF));
            document.open();
            double aZoom = surface.getZoom();
            surface.setZoom(1);
            PdfContentByte cb = writer.getDirectContent();
            cb.saveState();
            Graphics2D g2 = cb.createGraphics(surface.getSurfaceBounds().width, surface.getSurfaceBounds().height);
            surface.setExpPDF(true);
            surface.paintComponent(g2);
            surface.setExpPDF(false);
            g2.dispose();
            cb.restoreState();
            surface.setZoom(aZoom);
        } catch (DocumentException de) {
            System.err.println(de.getMessage());
        } catch (IOException ioe) {
            System.err.println(ioe.getMessage());
        }
        document.close();
    }
    
    public void exportPNG() {
        //Selection fichier é créer
        JFileChooser expPNG = new JFileChooser();
        ExampleFileFilter PNGFilter = new ExampleFileFilter("PNG"); //$NON-NLS-1$
        expPNG.setFileFilter(PNGFilter);
        expPNG.showSaveDialog(this);
        String fichierPNG = expPNG.getSelectedFile().getPath();
        if (fichierPNG.equals("")) //$NON-NLS-1$
            return;
        if (fichierPNG.substring(fichierPNG.length() - 4).toLowerCase().compareTo(".png") != 0) { //$NON-NLS-1$
            fichierPNG += ".png"; //$NON-NLS-1$
        }
        //Génération fichier
        try {
            File fichier = new File(fichierPNG);
            BufferedImage mImage;
            //Iterator pngWriters = ImageIO.getImageWritersByFormatName("png");
            //ImageWriter pngWriter = (ImageWriter)pngWriters.next();
            //ImageOutputStream ios = ImageIO.createImageOutputStream(fichier);
            //pngWriter.setOutput(ios);
            mImage = new BufferedImage(surface.getSurfaceBounds().width, surface.getSurfaceBounds().height, BufferedImage.TYPE_INT_RGB);
            double aZoom = surface.getZoom();
            surface.setZoom(1);
            Graphics2D g2 = mImage.createGraphics();
            surface.setExpPDF(true);
            g2.setBackground(Color.white);
            g2.setPaint(Color.white);
            g2.fillRect(0, 0, mImage.getWidth(), mImage.getHeight());
            surface.paintComponent(g2);
            //pngWriter.write(mImage);
            ImageIO.write(mImage, "png", fichier); //$NON-NLS-1$
            surface.setExpPDF(false);
            surface.setZoom(aZoom);
        } catch (IOException ioe) {
            System.err.println(ioe.getMessage());
        }
    }

    public FenetreMilieu getBase() {
        return base;
    }

    public void initComponents() {
        setPreferredSize(new Dimension(480, 560));
        surface = new DesignSurface(this);
        JPanel pouet = new JPanel();
        pouet.setPreferredSize(new Dimension(60, 100));

        jbZP = new JButton();
        jbZP.setIcon(createImageIcon("/ressources/bmepzp_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbZP.setPressedIcon(createImageIcon("/ressources/bmepzp_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbZP.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbZP.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbZP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                surfaceZoomP();
            }
        });
        pouet.add(jbZP);

        jbZM = new JButton();
        jbZM.setIcon(createImageIcon("/ressources/bmepzm_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbZM.setPressedIcon(createImageIcon("/ressources/bmepzm_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbZM.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbZM.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbZM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                surfaceZoomM();
            }
        });
        pouet.add(jbZM);

        jSeparator1 = new JSeparator();
        jSeparator1.setOrientation(javax.swing.SwingConstants.HORIZONTAL);
        jSeparator1.setPreferredSize(new java.awt.Dimension(40, 2));
        jSeparator1.setOpaque(true);
        pouet.add(jSeparator1);

        jbCa = new JButton();
        jbCa.setIcon(createImageIcon("/ressources/bmepca_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbCa.setPressedIcon(createImageIcon("/ressources/bmepca_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbCa.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbCa.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbCa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (base.fenetre == null) {
                    JOptionPane.showMessageDialog(base, Messages.getString("FenetreMiseEnPage.14")); //$NON-NLS-1$
                    return;
                }
                surface.setSouris("CarteDebut"); //$NON-NLS-1$
                surface.setSelectedObject(null);
                surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
            }
        });
        pouet.add(jbCa);

        jbLe = new JButton();
        jbLe.setIcon(createImageIcon("/ressources/bmepleg_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbLe.setPressedIcon(createImageIcon("/ressources/bmepleg_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbLe.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbLe.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbLe.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (base.fenLegende == null) {
                    JOptionPane.showMessageDialog(base, Messages.getString("FenetreMiseEnPage.20")); //$NON-NLS-1$
                    return;
                }
                surface.setSouris("LegendeDebut"); //$NON-NLS-1$
                surface.setSelectedObject(null);
                surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
            }
        });
        pouet.add(jbLe);

        jbEch = new JButton();
        jbEch.setIcon(createImageIcon("/ressources/bmepech_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEch.setPressedIcon(createImageIcon("/ressources/bmepech_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEch.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbEch.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbEch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (base.fenetre == null) {
                    JOptionPane.showMessageDialog(base, Messages.getString("FenetreMiseEnPage.20")); //$NON-NLS-1$
                    return;
                }
                ajoutEchelle();
                surface.setSouris("Echelle"); //$NON-NLS-1$
                surface.setSelectedObject(null);
                surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
            }
        });
        pouet.add(jbEch);
        
        jbNord = new JButton();
        jbNord.setIcon(createImageIcon("/ressources/bmepnord_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbNord.setPressedIcon(createImageIcon("/ressources/bmepnord_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbNord.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbNord.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbNord.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                surface.setSouris("Nord"); //$NON-NLS-1$
                surface.setSelectedObject(null);
                surface.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
            }
        });
        pouet.add(jbNord);
        
        jbTx = new JButton();
        jbTx.setIcon(createImageIcon("/ressources/bmeptex_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbTx.setPressedIcon(createImageIcon("/ressources/bmeptex_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbTx.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbTx.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbTx.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ajoutTexte();
            }
        });
        pouet.add(jbTx);

        jbRect = new JButton();
        jbRect.setIcon(createImageIcon("/ressources/bmeprect_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbRect.setPressedIcon(createImageIcon("/ressources/bmeprect_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbRect.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbRect.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbRect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ajoutRectangle();
            }
        });
        pouet.add(jbRect);
        
        jbEtiq = new JButton();
        jbEtiq.setIcon(createImageIcon("/ressources/bmepetiq_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEtiq.setPressedIcon(createImageIcon("/ressources/bmepetiq_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEtiq.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbEtiq.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbEtiq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (base.getTableau() == null) {
                    JOptionPane.showMessageDialog(base, Messages.getString("FenetreMiseEnPage.44")); //$NON-NLS-1$
                    return;
                } else {
                	ajoutEtiquette();
                }
            }
        });
        pouet.add(jbEtiq);

        jSeparator11 = new JSeparator();
        jSeparator11.setOrientation(javax.swing.SwingConstants.HORIZONTAL);
        jSeparator11.setPreferredSize(new java.awt.Dimension(40, 2));
        jSeparator11.setOpaque(true);
        pouet.add(jSeparator11);

        jbPDF = new JButton();
        jbPDF.setIcon(createImageIcon("/ressources/bmeppdf_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbPDF.setPressedIcon(createImageIcon("/ressources/bmeppdf_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbPDF.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbPDF.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbPDF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportPDF();
            }
        });
        pouet.add(jbPDF);

        jbPNG = new JButton();
        jbPNG.setIcon(createImageIcon("/ressources/bmeppng_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbPNG.setPressedIcon(createImageIcon("/ressources/bmeppng_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbPNG.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbPNG.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbPNG.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportPNG();
            }
        });
        pouet.add(jbPNG);

        jbEff = new JButton();
        jbEff.setIcon(createImageIcon("/ressources/bmepeff_r.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEff.setPressedIcon(createImageIcon("/ressources/bmepeff_a.png", "")); //$NON-NLS-1$ //$NON-NLS-2$
        jbEff.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
        jbEff.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jbEff.addActionListener(DSOListener);
        pouet.add(jbEff);

        //Dimensionnement selon page impression.
        PrinterJob pJ = PrinterJob.getPrinterJob();
        PageFormat pF = pJ.defaultPage();
        surface.setSurfaceBounds(new java.awt.Rectangle(0, 0, (int) pF.getPaper().getWidth(), (int) pF.getPaper().getHeight()));
        surface.setGridSize(1 / 39.37);
        surface.setSurfaceMargins(new java.awt.Rectangle((int) pF.getImageableX(), (int) pF.getImageableY(), (int) pF.getImageableWidth(), (int) pF.getImageableHeight()));
        surface.setZoom(1);
        zoomOrigine = surface.getZoom();

        surface.setPreferredSize(new Dimension(580, 800));
        JScrollPane sp = new JScrollPane(surface);
        sp.setBackground(Color.DARK_GRAY);
        getContentPane().add(sp, BorderLayout.CENTER);
        getContentPane().add(pouet, BorderLayout.EAST);
        pack();
        this.revalidate();
    }

    public String modifTexte(goTexte gotx) {
        String newTexte = (String) JOptionPane.showInputDialog(this.base, new FontChooser(this.fp, this.surface, gotx.getFont()), gotx.getTexte());
        if (newTexte == null)
            return "";
        else return newTexte;
    }

    public void surfaceZoomM() {
        if (surface.getZoom() > 0.2)
            surface.setZoom(surface.getZoom() - 0.2);
        surface.setPreferredSize(new Dimension((int) ((this.getWidth() + 120) * surface.getZoom()), (int) ((this.getHeight() + 260) * surface.getZoom())));
        surface.revalidate();
        this.repaint();
    }

    public void surfaceZoomP() {
        if (surface.getZoom() < 10)
            surface.setZoom(surface.getZoom() + 0.2);
        surface.setPreferredSize(new Dimension((int) ((this.getWidth() + 120) * surface.getZoom()), (int) ((this.getHeight() + 260) * surface.getZoom())));
        surface.revalidate();
        this.repaint();
    }
}