/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;
import javax.swing.UIManager;

import jxl.Workbook;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;
import carto.Carte;
import carto.FondCarte;
import donnees.champDonnees;

public class FenetrePrincipale extends JFrame implements ActionListener {

	public Vector c;

	public Vector t;

	public Carte carte;

	public Vector newC;

	public Vector newT;

	public String cheminFichOuv;

	public fichierINI fINI;

	public FichierSCAP fichier;

	public FenetrePrincipale() {
		fINI = new fichierINI();
		initComponents();
	}

	private void initComponents() {

		System.setErr(new MessageErreur(System.err));

		barreMenu = new JMenuBar();
		barreOutil = new BarreOutil(this);
		//panneauDroite = new PanneauDroite();
		panneauCentral = new FenetreMilieu(this);
		//arbre = new Arborescence();

		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}
		catch(InstantiationException e) {}
		catch(ClassNotFoundException e) {}
		catch(javax.swing.UnsupportedLookAndFeelException e) {}
		catch(IllegalAccessException e) {}

		setTitle(Messages.getString("FenetrePrincipale.0")); //$NON-NLS-1$        

		getContentPane().setLayout(new BorderLayout());
		this.setExtendedState(MAXIMIZED_BOTH);
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				exitForm(evt);
			}
		});

		rootPane.setBackground(Color.WHITE);

		getContentPane().add("North", barreOutil);

		getContentPane().add("Center", panneauCentral);

		//getContentPane().add("East", panneauDroite);

		//getContentPane().add("West", arbre);

		//Initialisation du Menu
		mFichier = new javax.swing.JMenu();
		itemOuvrir = new javax.swing.JMenuItem();
		itemEnregistrer = new javax.swing.JMenuItem();
		itemEnregistrerTout = new javax.swing.JMenuItem();
		itemFermer = new javax.swing.JMenuItem();
		jSeparator2 = new javax.swing.JSeparator();
		itemImporterMIF = new javax.swing.JMenuItem();
		/*
		 * itemExporter = new javax.swing.JMenu(); itemEMF = new
		 * javax.swing.JMenuItem(); itemPostscript = new
		 * javax.swing.JMenuItem(); itemBMP = new javax.swing.JMenuItem();
		 * jSeparator21 = new javax.swing.JSeparator();
		 */
		itemImportD = new javax.swing.JMenuItem();
		itemExportD = new javax.swing.JMenuItem();
		jSeparator211 = new javax.swing.JSeparator();
		itemImportDFlux = new javax.swing.JMenuItem();
		itemSupprDFlux = new javax.swing.JMenuItem();
		jSeparator2111 = new javax.swing.JSeparator();
		itemImprimer = new javax.swing.JMenuItem();
		itemPreference = new javax.swing.JMenuItem();
		jSeparator21111 = new javax.swing.JSeparator();
		itemNomEtud = new javax.swing.JMenuItem();
		jSeparator211111 = new javax.swing.JSeparator();
		itemQuitter = new javax.swing.JMenuItem();
		jSeparator2111111 = new javax.swing.JSeparator();
		itemDernier = new javax.swing.JMenuItem();
		jSeparator2211111 = new JSeparator();
		mEdition = new javax.swing.JMenu();
		itemCopierBMP = new javax.swing.JMenuItem();
		itemCopierEMF = new javax.swing.JMenuItem();
		itemCopierD = new javax.swing.JMenuItem();
		mCarte = new javax.swing.JMenu();
		itemChoroCouleur = new javax.swing.JMenuItem();
		itemChoroHach = new javax.swing.JMenuItem();
		jSeparator3 = new javax.swing.JSeparator();
		itemCarteLissee = new javax.swing.JMenuItem();
		jSeparator4 = new javax.swing.JSeparator();
		itemSymbolique = new javax.swing.JMenuItem();
		itemSymboliqueFlux = new javax.swing.JMenuItem();
		jSeparator5 = new javax.swing.JSeparator();
		itemSupprAnalyses = new javax.swing.JMenuItem();
		jSeparator10 = new javax.swing.JSeparator();
		//itemCarte3d = new javax.swing.JMenuItem();
		itemCarteJTS = new javax.swing.JMenuItem();
		mDonnees = new javax.swing.JMenu();
		itemCreerChamp = new javax.swing.JMenuItem();
		itemCalcChamp = new javax.swing.JMenuItem();
		itemSupprChamp = new javax.swing.JMenuItem();
		jSeparator6 = new javax.swing.JSeparator();
		itemTrier = new javax.swing.JMenuItem();
		itemCentrReduc = new javax.swing.JMenuItem();
		itemProj = new javax.swing.JMenuItem();
		mImage = new javax.swing.JMenu();
		itemOuvrirIm = new javax.swing.JMenuItem();
		itemFermerIm = new javax.swing.JMenuItem();
		mCommentaires = new javax.swing.JMenu();
		itemModifAjouComm = new javax.swing.JMenuItem();
		itemExportComm = new javax.swing.JMenuItem();
		mEnrichissements = new javax.swing.JMenu();
		itemAjouModifFond = new javax.swing.JMenuItem();
		itemSupprFond = new javax.swing.JMenuItem();
		itemEtiquetteAuto = new javax.swing.JMenuItem();
		itemEchGraph = new javax.swing.JMenu();
		itemAjoutEch = new javax.swing.JMenuItem();
		itemSupprEch = new javax.swing.JMenuItem();
		jSeparator7 = new javax.swing.JSeparator();
		itemAjoutSymb = new javax.swing.JMenuItem();
		itemDeplacerSymb = new javax.swing.JMenuItem();
		itemSupprSymb = new javax.swing.JMenuItem();
		itemSupprTousSymb = new javax.swing.JMenuItem();
		jSeparator8 = new javax.swing.JSeparator();
		itemAjouLib = new javax.swing.JMenuItem();
		itemDeplacerLib = new javax.swing.JMenuItem();
		itemModifTextLib = new javax.swing.JMenuItem();
		itemSupprLib = new javax.swing.JMenuItem();
		itemSupprTousLib = new javax.swing.JMenuItem();
		mFenetres = new javax.swing.JMenu();
		itemAffichDonneeFlux = new javax.swing.JMenuItem();
		jSeparator9 = new javax.swing.JSeparator();
		itemCascade = new javax.swing.JMenuItem();
		itemMosaV = new javax.swing.JMenuItem();
		itemMosaH = new javax.swing.JMenuItem();
		mAide = new javax.swing.JMenu();
		itemUtilisation = new javax.swing.JMenuItem();
		itemAPropos = new javax.swing.JMenuItem();
		itemMEP = new javax.swing.JMenuItem();

		mFichier.setText(Messages.getString("FenetrePrincipale.3")); //$NON-NLS-1$

		itemOuvrir.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
		itemOuvrir.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemOuvrir.setText(Messages.getString("FenetrePrincipale.5")); //$NON-NLS-1$
		itemOuvrir.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		itemOuvrir.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		itemOuvrir.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				ouvrirAction(evt);
			}
		});

		mFichier.add(itemOuvrir);

		itemEnregistrer.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
		itemEnregistrer.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemEnregistrer.setText(Messages.getString("FenetrePrincipale.7")); //$NON-NLS-1$
		itemEnregistrer.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		itemEnregistrer.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		itemEnregistrer.setEnabled(false);
		itemEnregistrer.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				EnregistrerAction(evt);
			}
		});
		mFichier.add(itemEnregistrer);

		itemFermer.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, java.awt.event.InputEvent.CTRL_MASK));
		itemFermer.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemFermer.setText(Messages.getString("FenetrePrincipale.9")); //$NON-NLS-1$
		itemFermer.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
		itemFermer.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		itemFermer.setEnabled(false);
		itemFermer.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				fermer();
			}
		});
		mFichier.add(itemFermer);
		mFichier.add(jSeparator2);

		itemImporterMIF.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemImporterMIF.setText(Messages.getString("FenetrePrincipale.11")); //$NON-NLS-1$
		itemImporterMIF.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				importerMIFAction(evt);
			}
		});
		mFichier.add(itemImporterMIF);

		/*
		 * itemExporter.setText("Exporter Carte"); itemExporter.setFont(new
		 * java.awt.Font("Dialog", 0, 10)); itemEMF.setFont(new
		 * java.awt.Font("Dialog", 0, 10)); itemEMF.setText("EMF");
		 * itemEMF.setEnabled(false); itemExporter.add(itemEMF);
		 * itemPostscript.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemPostscript.setText("Postscript");
		 * itemPostscript.setEnabled(false); itemExporter.add(itemPostscript);
		 * itemBMP.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemBMP.setText("BMP"); itemBMP.setEnabled(false);
		 * itemExporter.add(itemBMP); mFichier.add(itemExporter);
		 * 
		 * mFichier.add(jSeparator21);
		 * 
		 * itemImportDFlux.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemImportDFlux.setText("Importer donn\u00e9es de flux");
		 * itemImportDFlux.setEnabled(false); mFichier.add(itemImportDFlux);
		 * 
		 * itemSupprDFlux.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprDFlux.setText("Supprimer donn\u00e9es de flux");
		 * itemSupprDFlux.setEnabled(false); mFichier.add(itemSupprDFlux);
		 * 
		 * mFichier.add(jSeparator2111);
		 * 
		 * itemImprimer.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemImprimer.setText("Imprimer"); itemImprimer.setEnabled(false);
		 * mFichier.add(itemImprimer);
		 * 
		 * itemPreference.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemPreference.setText("Pr\u00e9f\u00e9rences");
		 * mFichier.add(itemPreference);
		 * 
		 * mFichier.add(jSeparator21111);
		 * 
		 * itemNomEtud.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemNomEtud.setText("Entrer nom \u00e9tudiant");
		 * mFichier.add(itemNomEtud);
		 * 
		 * mFichier.add(jSeparator211111);
		 */

		mFichier.add(jSeparator2111111);

		itemQuitter.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
		itemQuitter.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemQuitter.setText(Messages.getString("FenetrePrincipale.13")); //$NON-NLS-1$
		itemQuitter.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemQuitterActionPerformed(evt);
			}
		});

		mFichier.add(itemQuitter);

		itemDernier.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_1, java.awt.event.InputEvent.CTRL_MASK));
		itemDernier.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemDernier.setText(fINI.getName());
		itemDernier.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemDernierActionPerformed(evt);
			}
		});

		mFichier.add(itemDernier);

		mFichier.add(jSeparator2211111);

		barreMenu.add(mFichier);

		// MENU EDITION
		/*
		 * mEdition.setText("Edition");
		 * 
		 * itemCopierBMP.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemCopierBMP.setText("Copier carte BMP");
		 * itemCopierBMP.setEnabled(false); mEdition.add(itemCopierBMP);
		 * 
		 * itemCopierEMF.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemCopierEMF.setText("Copier carte EMF");
		 * itemCopierEMF.setEnabled(false); mEdition.add(itemCopierEMF);
		 * 
		 * itemCopierD.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemCopierD.setText("Copier donn\u00e9es");
		 * itemCopierD.setEnabled(false); mEdition.add(itemCopierD);
		 * 
		 * barreMenu.add(mEdition);
		 */

		// MENU CARTE
		mCarte.setText(Messages.getString("FenetrePrincipale.14")); //$NON-NLS-1$
		itemChoroCouleur.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemChoroCouleur.setText(Messages.getString("FenetrePrincipale.16")); //$NON-NLS-1$
		itemChoroCouleur.setEnabled(false);
		itemChoroCouleur.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemChoroCouleurActionPerformed(evt);
			}
		});
		mCarte.add(itemChoroCouleur);

		/*
		 * itemChoroHach.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemChoroHach.setText("Choropl\u00e8the : Hachures NB");
		 * itemChoroHach.setEnabled(false); mCarte.add(itemChoroHach);
		 * 
		 * jSeparator3.setPreferredSize(new java.awt.Dimension(200, 10));
		 * mCarte.add(jSeparator3);
		 * 
		 * itemCarteLissée.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemCarteLissée.setText("Carte liss\u00e9e");
		 * itemCarteLissée.setEnabled(false); mCarte.add(itemCarteLissée);
		 * jSeparator4.setPreferredSize(new java.awt.Dimension(200, 10));
		 * mCarte.add(jSeparator4);
		 */

		itemSymbolique.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemSymbolique.setText(Messages.getString("FenetrePrincipale.18")); //$NON-NLS-1$
		itemSymbolique.setEnabled(false);
		itemSymbolique.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemSymboliqueActionPerformed(evt);
			}
		});
		mCarte.add(itemSymbolique);

		/*
		 * itemSymboliqueFlux.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSymboliqueFlux.setText("Symbolique de flux");
		 * itemSymboliqueFlux.setEnabled(false); mCarte.add(itemSymboliqueFlux);
		 * 
		 * jSeparator5.setPreferredSize(new java.awt.Dimension(200, 10));
		 * mCarte.add(jSeparator5);
		 */

		itemSupprAnalyses.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemSupprAnalyses.setText(Messages.getString("FenetrePrincipale.20")); //$NON-NLS-1$
		itemSupprAnalyses.setEnabled(false);
		itemSupprAnalyses.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				recyclage();
			}
		});
		mCarte.add(itemSupprAnalyses);

//		mCarte.add(jSeparator10);
//
//		itemCarte3d.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
//		itemCarte3d.setText(Messages.getString("FenetrePrincipale.85")); //$NON-NLS-1$
//		itemCarte3d.setEnabled(false);
//		itemCarte3d.addActionListener(new java.awt.event.ActionListener() {
//			public void actionPerformed(java.awt.event.ActionEvent evt) {
//				itemCarte3dActionPerformed(evt);
//			}
//		});
//		mCarte.add(itemCarte3d);
		
		mCarte.add(jSeparator10);
		
		itemCarteJTS.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemCarteJTS.setText(Messages.getString("FenetrePrincipale.86")); //$NON-NLS-1$
		itemCarteJTS.setEnabled(true);
		itemCarteJTS.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemCarteJTSActionPerformed(evt);
			}
		});
		mCarte.add(itemCarteJTS);

		barreMenu.add(mCarte);

		// MENU DONNEES

		mDonnees.setText(Messages.getString("FenetrePrincipale.21")); //$NON-NLS-1$

		itemImportD.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemImportD.setText(Messages.getString("FenetrePrincipale.23")); //$NON-NLS-1$
		itemImportD.setEnabled(false);
		itemImportD.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				importDAction(evt);
			}
		});
		mDonnees.add(itemImportD);

		itemExportD.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemExportD.setText(Messages.getString("FenetrePrincipale.25")); //$NON-NLS-1$
		itemExportD.setEnabled(false);
		itemExportD.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				exporterXLS();
			}
		});
		mDonnees.add(itemExportD);

		mDonnees.add(jSeparator211);

		itemCreerChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemCreerChamp.setText(Messages.getString("FenetrePrincipale.27")); //$NON-NLS-1$
		itemCreerChamp.setEnabled(false);
		itemCreerChamp.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemCreerChampActionPerformed(evt);
			}
		});
		mDonnees.add(itemCreerChamp);

		 itemCalcChamp.setFont(new java.awt.Font("Dialog", 0, 10));
		 itemCalcChamp.setText(Messages.getString("FenetrePrincipale.90"));
		 itemCalcChamp.setEnabled(false); itemCalcChamp.addActionListener(new
		 java.awt.event.ActionListener() { public void
		 actionPerformed(java.awt.event.ActionEvent evt) {
		 itemCalcChampActionPerformed(evt); } }); mDonnees.add(itemCalcChamp);

		itemSupprChamp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemSupprChamp.setText(Messages.getString("FenetrePrincipale.29")); //$NON-NLS-1$
		itemSupprChamp.setEnabled(false);
		itemSupprChamp.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemSupprChampActionPerformed(evt);
			}
		});
		mDonnees.add(itemSupprChamp);

		jSeparator6.setPreferredSize(new java.awt.Dimension(200, 10));
		mDonnees.add(jSeparator6);

		/*
		 * itemTrier.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemTrier.setText("Trier"); itemTrier.setEnabled(false);
		 * mDonnees.add(itemTrier); itemTrier.addActionListener(new
		 * java.awt.event.ActionListener() { public void
		 * actionPerformed(java.awt.event.ActionEvent evt) {
		 * itemTrierActionPerformed(evt); } }); mDonnees.add(itemSupprChamp);
		 */

		itemCentrReduc.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemCentrReduc.setText(Messages.getString("FenetrePrincipale.31")); //$NON-NLS-1$
		itemCentrReduc.setEnabled(false);
		itemCentrReduc.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				itemCentrerReduireActionPerformed(evt);
			}
		});
		mDonnees.add(itemCentrReduc);

		/*
		 * itemProj.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemProj.setText("Projections"); itemProj.setEnabled(false);
		 * itemProj.addActionListener(new java.awt.event.ActionListener() {
		 * public void actionPerformed(java.awt.event.ActionEvent evt) {
		 * itemProjeterActionPerformed(evt); } }); mDonnees.add(itemProj);
		 */

		barreMenu.add(mDonnees);

		// MENU IMAGES

		/*
		 * mImage.setText("Images"); itemOuvrirIm.setFont(new
		 * java.awt.Font("Dialog", 0, 10)); itemOuvrirIm.setText("Ouvrir");
		 * mImage.add(itemOuvrirIm);
		 * 
		 * itemFermerIm.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemFermerIm.setText("Fermer"); itemFermerIm.setEnabled(false);
		 * mImage.add(itemFermerIm);
		 * 
		 * barreMenu.add(mImage); // MENU COM
		 * 
		 * mCommentaires.setText("Commentaires"); itemModifAjouComm.setFont(new
		 * java.awt.Font("Dialog", 0, 10));
		 * itemModifAjouComm.setText("Ajouter/Modifier un commentaire");
		 * itemModifAjouComm.setEnabled(false);
		 * mCommentaires.add(itemModifAjouComm);
		 * 
		 * itemExportComm.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemExportComm.setText("Exporter un commentaire en RTF");
		 * itemExportComm.setEnabled(false); mCommentaires.add(itemExportComm);
		 * 
		 * barreMenu.add(mCommentaires); // MENU ENRICHISSEMENTS
		 * 
		 * mEnrichissements.setText("Enrichissements");
		 * itemAjouModifFond.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemAjouModifFond.setText("Ajout/Modif fond d'habillage");
		 * itemAjouModifFond.setEnabled(false);
		 * mEnrichissements.add(itemAjouModifFond);
		 * 
		 * itemSupprFond.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprFond.setText("Supprimer fond d'habillage");
		 * itemSupprFond.setEnabled(false); mEnrichissements.add(itemSupprFond);
		 * 
		 * itemEtiquetteAuto.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemEtiquetteAuto.setText("Etiquettes Auto");
		 * itemEtiquetteAuto.setEnabled(false);
		 * mEnrichissements.add(itemEtiquetteAuto);
		 * 
		 * itemEchGraph.setText("Echelle graphique"); itemEchGraph.setFont(new
		 * java.awt.Font("Dialog", 0, 10)); itemEchGraph.setEnabled(false);
		 * itemAjoutEch.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemAjoutEch.setText("Ajouter echelle");
		 * itemEchGraph.add(itemAjoutEch); itemSupprEch.setFont(new
		 * java.awt.Font("Dialog", 0, 10)); itemSupprEch.setText("Supprimer
		 * echelle"); itemEchGraph.add(itemSupprEch);
		 * mEnrichissements.add(itemEchGraph);
		 * 
		 * jSeparator7.setPreferredSize(new java.awt.Dimension(200, 10));
		 * mEnrichissements.add(jSeparator7);
		 * 
		 * itemAjoutSymb.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemAjoutSymb.setText("Ajouter un symbole");
		 * itemAjoutSymb.setEnabled(false); mEnrichissements.add(itemAjoutSymb);
		 * 
		 * itemDeplacerSymb.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemDeplacerSymb.setText("D\u00e9placer un symbole");
		 * itemDeplacerSymb.setEnabled(false);
		 * mEnrichissements.add(itemDeplacerSymb);
		 * 
		 * itemSupprSymb.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprSymb.setText("Supprimer un symbole");
		 * itemSupprSymb.setEnabled(false); mEnrichissements.add(itemSupprSymb);
		 * 
		 * itemSupprTousSymb.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprTousSymb.setText("Supprimer tous les symboles");
		 * itemSupprTousSymb.setEnabled(false);
		 * mEnrichissements.add(itemSupprTousSymb);
		 * 
		 * jSeparator8.setPreferredSize(new java.awt.Dimension(200, 10));
		 * mEnrichissements.add(jSeparator8);
		 * 
		 * itemAjouLib.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemAjouLib.setText("Ajouter un libell\u00e9");
		 * itemAjouLib.setEnabled(false); mEnrichissements.add(itemAjouLib);
		 * 
		 * itemDeplacerLib.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemDeplacerLib.setText("D\u00e9placer un libell\u00e9");
		 * itemDeplacerLib.setEnabled(false);
		 * mEnrichissements.add(itemDeplacerLib);
		 * 
		 * itemModifTextLib.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemModifTextLib.setText("Modifier un texte d'un libell\u00e9");
		 * itemModifTextLib.setEnabled(false);
		 * mEnrichissements.add(itemModifTextLib);
		 * 
		 * itemSupprLib.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprLib.setText("Supprimer un libell\u00e9");
		 * itemSupprLib.setEnabled(false); mEnrichissements.add(itemSupprLib);
		 * 
		 * itemSupprTousLib.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemSupprTousLib.setText("Supprimer tous les libell\u00e9s");
		 * itemSupprTousLib.setEnabled(false);
		 * mEnrichissements.add(itemSupprTousLib);
		 * 
		 * barreMenu.add(mEnrichissements);
		 */

		// MENU FENETRES
		mFenetres.setText(Messages.getString("FenetrePrincipale.32")); //$NON-NLS-1$
		/*
		 * itemAffichDonnéeFlux.setFont(new java.awt.Font("Dialog", 0, 10));
		 * itemAffichDonnéeFlux.setText("Afficher donn\u00e9es de flux");
		 * itemAffichDonnéeFlux.setEnabled(false);
		 * mFenetres.add(itemAffichDonnéeFlux);
		 */

		itemMEP.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemMEP.setText(Messages.getString("FenetrePrincipale.34")); //$NON-NLS-1$
		itemMEP.setEnabled(true);
		itemMEP.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				afficheMiseEnPage();
			}
		});
		mFenetres.add(itemMEP);

		jSeparator9.setPreferredSize(new java.awt.Dimension(200, 10));
		mFenetres.add(jSeparator9);

		itemCascade.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemCascade.setText(Messages.getString("FenetrePrincipale.36")); //$NON-NLS-1$
		itemCascade.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cascade(evt);
			}
		});
		mFenetres.add(itemCascade);

		itemMosaV.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F2, 0));
		itemMosaV.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemMosaV.setText(Messages.getString("FenetrePrincipale.38")); //$NON-NLS-1$
		mFenetres.add(itemMosaV);
		itemMosaV.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				mosaique(evt);
			}
		});

		itemMosaH.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemMosaH.setText(Messages.getString("FenetrePrincipale.40")); //$NON-NLS-1$
		mFenetres.add(itemMosaH);

		barreMenu.add(mFenetres);

		// MENU AIDE

		mAide.setText(Messages.getString("FenetrePrincipale.41")); //$NON-NLS-1$
		itemUtilisation.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemUtilisation.setText(Messages.getString("FenetrePrincipale.43")); //$NON-NLS-1$
		itemUtilisation.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				appelAide();
			}
		});
		mAide.add(itemUtilisation);

		itemAPropos.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemAPropos.setText(Messages.getString("FenetrePrincipale.45")); //$NON-NLS-1$
		itemAPropos.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				afficheBDAPropos();
			}
		});
		mAide.add(itemAPropos);

		barreMenu.add(mAide);
		//Fin de l'initialisation du menu

		this.setJMenuBar(barreMenu);

		Image icone = createImage("/ressources/icone.png"); //$NON-NLS-1$
		this.setIconImage(icone);
	}

	protected void itemCarteJTSActionPerformed(ActionEvent evt) {
		panneauCentral.fenetre.panneauCarte.getFondCarte().testJTS();
		//panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
		//panneauCentral.fenetre.panneauCarte.repaint();
	}

	private void afficheBDAPropos() {
		BoiteDialogueAPropos bdAPropos = new BoiteDialogueAPropos(this, false);
		bdAPropos.setLocationRelativeTo(this);
		bdAPropos.setVisible(true);
	}

	/**
	 *  
	 */
	protected void appelAide() {
		BrowserControl.displayURL("File:/" + FenetrePrincipale.class.getResource("/ressources/scapj_aide.html").getPath()); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt) {
		if (fichier != null) {
			if (fichier.getfichierFond() != null)
				fichier.getfichierFond().delete();
			if (fichier.getfichierDonnees() != null)
				fichier.getfichierDonnees().delete();
			if (fichier.getfichierCarte() != null)
				fichier.getfichierCarte().delete();
			if (fichier.getfichierTemp() != null)
				fichier.getfichierTemp().delete();
		}
		System.exit(0);
	}

	private void cascade(ActionEvent evt) {
		this.panneauCentral.fenetreCascade();
	}

	private void mosaique(ActionEvent evt) {
		this.panneauCentral.fenetreMosaique();
	}

	public void EnregistrerAction(java.awt.event.ActionEvent evt) {
		ExampleFileFilter scapFondFilter = new ExampleFileFilter("scap"); //$NON-NLS-1$
		JFileChooser saveF = new JFileChooser();
		saveF.setDialogTitle(Messages.getString("FenetrePrincipale.50")); //$NON-NLS-1$
		saveF.setFileFilter(scapFondFilter);
		int returnVal = saveF.showSaveDialog(this);
		if (returnVal == JFileChooser.CANCEL_OPTION) { //$NON-NLS-1$
			return;
		}
		String fichierE = saveF.getSelectedFile().getPath();
		if (fichierE.endsWith(".scap") == false) { //$NON-NLS-1$
			fichierE += ".scap"; //$NON-NLS-1$
		}

		enregistrement(fichierE);
	}

	public void enregistrement(String fichierE) {
		int panneauC = 99;
		int panneauD = 99;
		FondCarte fond;
		JInternalFrame[] fenetres = this.panneauCentral.getAllFrames();
		for (int i = 0; i < fenetres.length; i++) {
			if (fenetres[i].getTitle().equals(Messages.getString("FenetrePrincipale.54"))) { //$NON-NLS-1$
				panneauC = i;
			}
			if (fenetres[i].getTitle().equals(Messages.getString("FenetrePrincipale.55"))) { //$NON-NLS-1$
				panneauD = i;
			}
		}
		if (panneauC == 99) {
			return;
		}
		fond = ((FenetreCarte) (fenetres[panneauC])).panneauCarte.getFondCarte();
		fichier.enregistrerZIP(fichierE, fond, c, t, carte);

		JMenuItem itemChem = new javax.swing.JMenuItem();
		itemChem.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
		itemChem.setText(fichierE);
		itemChem.setEnabled(true);
		mFichier.add(itemChem);

		this.setCursor(new Cursor(3));
		//this.panneauCentral.creerFenetreEnregistrer(fichierE);
		itemCreerChamp.setEnabled(true);
		itemCalcChamp.setEnabled(true);
		itemSupprChamp.setEnabled(true);
		itemTrier.setEnabled(true);
		itemCentrReduc.setEnabled(true);
		itemProj.setEnabled(true);
		this.setCursor(new Cursor(0));
	}

	public void ouvrirAction(java.awt.event.ActionEvent evt) {
		JFileChooser ouv = new JFileChooser();
		ExampleFileFilter scapCarteFilter = new ExampleFileFilter("scap"); //$NON-NLS-1$
		ouv.setFileFilter(scapCarteFilter);     
		int returnVal = ouv.showOpenDialog(this);
		if (returnVal == JFileChooser.CANCEL_OPTION) { //$NON-NLS-1$
			return;
		}
		String fichierO = ouv.getSelectedFile().getPath();

		if (fichierO.compareTo("null") != 0) { //$NON-NLS-1$
			ouverture(fichierO);
		}
	}

	public void ouverture(String fichierO) {
		fichier = new FichierSCAP(fichierO);
		this.setCursor(new Cursor(3));
		fINI.ecrire(fichierO);
		itemDernier.setText(fichierO);
		this.panneauCentral.creerFenetreDonnees(this, fichier.getfichierDonnees().getPath());
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getDataVector();
		//Lecture fichier carte éventuel
		if (fichier.getfichierCarte() != null) {
			try {
				FileInputStream in = new FileInputStream(fichier.getfichierCarte().getName());
				ObjectInputStream s = new ObjectInputStream(in);
				this.carte = null;
				this.carte = (Carte) s.readObject();
				//Ouverture fenétre graphique carte
				this.panneauCentral.creerFenetreCarte(this, Messages.getString("FenetrePrincipale.59"), fichier.getfichierFond().getPath()); //$NON-NLS-1$
				this.panneauCentral.fenetre.panneauCarte.getFondCarte().setTableauCols(t, c);
				this.panneauCentral.fenetre.panneauCarte.getFondCarte().setCarte(carte);
				this.panneauCentral.fenetre.panneauCarte.setCarte(carte);
				this.panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
				itemSupprAnalyses.setEnabled(true);
				this.barreOutil.bCorbeille.setEnabled(true);
				if (carte.getTypeAnalyse() != 0) {
					if (this.panneauCentral.fenLegende == null) {
						this.panneauCentral.creerFenetreLegende(carte);
					} else {
						this.panneauCentral.fenLegende.panneauLegende.setCarte(carte);
					}
					/*if (this.panneauCentral.fen3D != null) {
						this.panneauCentral.fen3D.refresh();
					}*/
					this.panneauCentral.fenLegende.repaint();
				}
			} catch (ClassNotFoundException cnfe) {
				System.out.println(Messages.getString("FenetrePrincipale.60")); //$NON-NLS-1$
				cnfe.printStackTrace();
			} catch (IOException ioe) {
				ioe.printStackTrace();
			}
		} else {
			//Ouverture fenétre graphique vide
			this.panneauCentral.creerFenetreCarte(this, Messages.getString("FenetrePrincipale.61"), fichier.getfichierFond().getPath()); //$NON-NLS-1$
			this.panneauCentral.fenetre.panneauCarte.setCarte(this.panneauCentral.fenetre.panneauCarte.getFondCarte().getCarte());
			carte = this.panneauCentral.fenetre.panneauCarte.getFondCarte().getCarte();
		}
		//Mise é jour interface
		itemEnregistrer.setEnabled(true);
		itemOuvrir.setEnabled(false);
		itemImportD.setEnabled(true);
		itemExportD.setEnabled(true);
		itemFermer.setEnabled(true);
		itemChoroCouleur.setEnabled(true);
		itemChoroHach.setEnabled(true);
		itemSymbolique.setEnabled(true);
		//itemCarte3d.setEnabled(true);
		itemCreerChamp.setEnabled(true);
		itemCalcChamp.setEnabled(true);
		itemSupprChamp.setEnabled(true);
		itemTrier.setEnabled(true);
		itemCentrReduc.setEnabled(true);
		itemProj.setEnabled(true);
		this.barreOutil.bEnregistrer.setEnabled(true);
		this.barreOutil.bChoroplethe.setEnabled(true);
		this.barreOutil.bSymbol.setEnabled(true);
		//this.barreOutil.bInfo.setEnabled(true);
		this.panneauCentral.fenetre.panneauCarte.grabFocus();
		itemMosaV.doClick();
		if (this.carte.analysePlages.champNum != -1 || this.carte.analyseSymb.champNum != -1 && this.panneauCentral.fenLegende == null)
			this.panneauCentral.creerFenetreLegende(carte);
		this.setCursor(new Cursor(0));
		this.panneauCentral.fenetre.panneauCarte.paintImmediately(0, 0, 10, 10);
	}

	public void importDAction(ActionEvent evt) {
		JFileChooser importD = new JFileChooser();
		ExampleFileFilter scapCarteFilter = new ExampleFileFilter("xls"); //$NON-NLS-1$
		scapCarteFilter.addExtension("dbf");
		importD.setFileFilter(scapCarteFilter);
		importD.setDialogTitle(Messages.getString("FenetrePrincipale.63")); //$NON-NLS-1$
		importD.showOpenDialog(this);
		if (importD.getSelectedFile() == null)
			return;
		this.setCursor(new Cursor(3));
		String fichierImport = importD.getSelectedFile().getPath();
		BoiteDialogueImportXLS bdImportD = new BoiteDialogueImportXLS(this, true, Messages.getString("FenetrePrincipale.64"), c, t, fichierImport); //$NON-NLS-1$
		bdImportD.setLocationRelativeTo(this);
		bdImportD.setVisible(true);
		this.panneauCentral.creeFenetreDonneesImportXLS(c, t, newC, newT);
		c = this.panneauCentral.getColumnNames();
		t = this.panneauCentral.getDataVector();
		this.setCursor(new Cursor(0));
	}

	public void importerMIFAction(java.awt.event.ActionEvent evt) {
		//Importation d'un couple de fichier mif/mid
		JFileChooser impMIF = new JFileChooser();
		ExampleFileFilter MIFFilter = new ExampleFileFilter("mif"); //$NON-NLS-1$
		impMIF.setFileFilter(MIFFilter);
		impMIF.showOpenDialog(this);
		if (impMIF.getSelectedFile() == null) return;
		String dir = impMIF.getSelectedFile().getPath();
		String cheminFic = impMIF.getSelectedFile().getName();
		cheminFichOuv = dir;
		this.panneauCentral.creerFenetreCarteMIF(this, cheminFic, cheminFichOuv);

		if (cheminFichOuv.compareTo("null") != 0) { //controle si un //$NON-NLS-1$
			// //$NON-NLS-1$
			JMenuItem itemChem = new javax.swing.JMenuItem();
			itemChem.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
			itemChem.setText(cheminFichOuv);
			itemChem.setEnabled(true);
			itemEnregistrer.setEnabled(true);
			mFichier.add(itemChem);
			itemFermer.setEnabled(true);

			this.setCursor(new Cursor(3));
			this.panneauCentral.creerFenetreDonneesMID(cheminFichOuv);
			c = panneauCentral.getColumnNames();
			t = panneauCentral.getDataVector();
			carte = panneauCentral.getFenetreCarte().getPanneauCarte().getCarte();
			itemOuvrir.setEnabled(false);
			itemImportD.setEnabled(true);
			itemExportD.setEnabled(true);
			itemFermer.setEnabled(true);
			itemChoroCouleur.setEnabled(true);
			itemChoroHach.setEnabled(true);
			itemSymbolique.setEnabled(true);
			//itemCarte3d.setEnabled(true);
			itemCreerChamp.setEnabled(true);
			itemCalcChamp.setEnabled(true);
			itemSupprChamp.setEnabled(true);
			itemTrier.setEnabled(true);
			itemCentrReduc.setEnabled(true);
			itemProj.setEnabled(true);
			this.barreOutil.bEnregistrer.setEnabled(true);
			this.barreOutil.bChoroplethe.setEnabled(true);
			this.barreOutil.bSymbol.setEnabled(true);
			//this.barreOutil.bInfo.setEnabled(true);
			itemMosaV.doClick();
		}
		this.setCursor(new Cursor(0));
		String baseDir = System.getProperty("user.dir"); //$NON-NLS-1$
		String nouveau = baseDir + System.getProperty("file.separator") + "temp.scap"; //$NON-NLS-1$ //$NON-NLS-2$
		fichier = new FichierSCAP();
		enregistrement(nouveau);
		this.panneauCentral.fenetre.panneauCarte.paintImmediately(0, 0, 10, 10);
	}

	private void exporterXLS() {
		int i = 0;
		int j = 0;
		int nbRows = t.size() / c.size();
		ExampleFileFilter scapFondFilter = new ExampleFileFilter("xls"); //$NON-NLS-1$
		JFileChooser saveF = new JFileChooser();
		saveF.setDialogTitle(Messages.getString("FenetrePrincipale.72")); //$NON-NLS-1$
		saveF.setFileFilter(scapFondFilter);
		saveF.showSaveDialog(this);
		//Confirmation remplacement
		if (saveF.getSelectedFile().exists()) {
			int reponse = JOptionPane.showConfirmDialog(this, Messages.getString("FenetrePrincipale.73")); //$NON-NLS-1$
			if (reponse == JOptionPane.NO_OPTION || reponse == JOptionPane.CANCEL_OPTION)
				return;
		}
		String fichierXLS = saveF.getSelectedFile().getPath();
		if (fichierXLS.equals("null")) { //$NON-NLS-1$
			return;
		}
		if (fichierXLS.endsWith(".xls") == false) { //$NON-NLS-1$
			fichierXLS += ".xls"; //$NON-NLS-1$
		}
		//Ecriture
		try {
			WritableWorkbook workbook = Workbook.createWorkbook(new File(fichierXLS));
			WritableSheet sheet = workbook.createSheet("Données SCAPJ", 0); //$NON-NLS-1$
			//En-tétes
			for (i = 0; i < c.size(); i++) {
				Label lchamp = new Label(i, 0, ((champDonnees) c.elementAt(i)).nom);
				sheet.addCell(lchamp);
			}
			//Données
			for (i = 0; i < nbRows; i++) {
				for (j = 0; j < c.size(); j++) {
					switch (((champDonnees) c.elementAt(j)).typeI) {
					case 0:
						Number lEntier = new Number(j, i + 1, ((Integer) t.elementAt((i * c.size()) + j)).doubleValue());
						sheet.addCell(lEntier);
						break;
					case 1:
						Label lTexte = new Label(j, i + 1, (String) t.elementAt((i * c.size()) + j));
						sheet.addCell(lTexte);
						break;
					case 2:
						Number lVirgule = new Number(j, i + 1, ((Double) t.elementAt((i * c.size()) + j)).doubleValue());
						sheet.addCell(lVirgule);
						break;
					}
				}
			}
			workbook.write();
			workbook.close();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} catch (RowsExceededException e) {
			e.printStackTrace();
		} catch (WriteException e) {
			e.printStackTrace();
		}
	}

	private void itemSupprChampActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueSupprChamp bdSupprChamp = new BoiteDialogueSupprChamp(this, t, c); //apelle
		bdSupprChamp.afficherBoiteDialogue(); // affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemCreerChampActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueCreerChamp bdCreerChamp = new BoiteDialogueCreerChamp(this, c, t);//apelle
		bdCreerChamp.afficherBoiteDialogue();// affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemTrierActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueTrier bdTrierChamp = new BoiteDialogueTrier(this, c, t);//apelle
		bdTrierChamp.afficherBoiteDialogue();// affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemCalcChampActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueCalcChamp bdCalcChamp = new BoiteDialogueCalcChamp(this, c, t);//apelle
		bdCalcChamp.afficherBoiteDialogue();// affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemCentrerReduireActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueCentreReduireChamp bdCRChamp = new BoiteDialogueCentreReduireChamp(this, c, t);//apelle
		bdCRChamp.afficherBoiteDialogue(); // affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemProjeterActionPerformed(java.awt.event.ActionEvent evt) {
		BoiteDialogueProjeter bdProj = new BoiteDialogueProjeter(this, c, t);//apelle
		bdProj.afficherBoiteDialogue(); // affiche la BD
		c = panneauCentral.getColumnNames();
		t = panneauCentral.getTableau();
	}

	private void itemChoroCouleurActionPerformed(java.awt.event.ActionEvent evt) {
		afficheBDChoroCouleur();
	}

	private void itemSymboliqueActionPerformed(ActionEvent evt) {
		afficheBDSymbolique();
	}

	public void afficherTableSupprCol(int champ) {
		this.panneauCentral.creerFenetreSupprCol(Messages.getString("FenetrePrincipale.78"), champ); //$NON-NLS-1$
	}

	public void afficherTableAjouterCol(String champ) {
		this.panneauCentral.creerFenetreAjouterCol(Messages.getString("FenetrePrincipale.79"), champ); //$NON-NLS-1$
	}

	public void afficherTableTrierCol(String champ, boolean ordre) {
		//Fonction inutile
	}

	public void afficherTableCentrerReduireCol(String champ, String champAcreer) {
		this.panneauCentral.creerFenetreCentrerReduireCol(Messages.getString("FenetrePrincipale.80"), champ, champAcreer); //$NON-NLS-1$
	}

	public void afficherTableCalculerCol(String champAcreer, String formule) {
		this.panneauCentral.creerFenetreCalculerChp(champAcreer, formule);
	}

	public void afficherTableProjeter(String champAcreer, String varDepart, String varArrive, int ecartAnnee, int ecartAnneeProj) {
		this.panneauCentral.creerFenetreProjeter(champAcreer, varDepart, varArrive, ecartAnnee, ecartAnneeProj);
	}

/*	private void itemCarte3dActionPerformed(ActionEvent evt) {
		this.panneauCentral.creerFenetre3D(this);
	}*/

	private void fermer() {
		if (fichier != null) {
			if (fichier.getfichierFond() != null)
				fichier.getfichierFond().delete();
			if (fichier.getfichierDonnees() != null)
				fichier.getfichierDonnees().delete();
			if (fichier.getfichierCarte() != null)
				fichier.getfichierCarte().delete();
			if (fichier.getfichierTemp() != null)
				fichier.getfichierTemp().delete();
		}
		JInternalFrame[] fenetres = this.panneauCentral.getAllFrames();
		for (int i = 0; i < fenetres.length; i++) {
			fenetres[i].dispose();
		}
		//Mise é jour interface
		itemOuvrir.setEnabled(true);
		itemEnregistrer.setEnabled(false);
		itemImportD.setEnabled(false);
		itemExportD.setEnabled(false);
		itemFermer.setEnabled(false);
		itemChoroCouleur.setEnabled(false);
		itemChoroHach.setEnabled(false);
		itemSymbolique.setEnabled(false);
		//itemCarte3d.setEnabled(false);
		itemCreerChamp.setEnabled(false);
		itemCalcChamp.setEnabled(false);
		itemSupprChamp.setEnabled(false);
		itemTrier.setEnabled(false);
		itemCentrReduc.setEnabled(false);
		itemProj.setEnabled(false);
		this.barreOutil.bEnregistrer.setEnabled(false);
		this.barreOutil.bChoroplethe.setEnabled(false);
		this.barreOutil.bSymbol.setEnabled(false);
		//this.barreOutil.bInfo.setEnabled(false);
	}

	private void itemQuitterActionPerformed(java.awt.event.ActionEvent evt) {
		if (fichier != null) {
			if (fichier.getfichierFond() != null)
				fichier.getfichierFond().delete();
			if (fichier.getfichierDonnees() != null)
				fichier.getfichierDonnees().delete();
			if (fichier.getfichierCarte() != null)
				fichier.getfichierCarte().delete();
			if (fichier.getfichierTemp() != null)
				fichier.getfichierTemp().delete();
		}
		System.exit(0);
	}

	private void itemDernierActionPerformed(java.awt.event.ActionEvent evt) {
		ouverture(fINI.getPath());
	}

	public void actionPerformed(java.awt.event.ActionEvent actionEvent) {

	}

	public void afficheBDChoroCouleur() {
		if (carte.analysePlages.champNum != -1 && carte.getTypeAnalyse() != 1) {
			//carte.recyclage();
			panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
		}
		BoiteDialogueChoroCouleur bdChoro = new BoiteDialogueChoroCouleur(this, true, Messages.getString("FenetrePrincipale.81"), c, t); //$NON-NLS-1$
		bdChoro.setLocationRelativeTo(this);
		bdChoro.setVisible(true);
		if (carte.analysePlages.champNum != -1) {
			c = panneauCentral.getColumnNames();
			t = panneauCentral.getTableau();
			panneauCentral.fenetre.panneauCarte.getFondCarte().setTableauCols(t, c);
			panneauCentral.fenetre.panneauCarte.getFondCarte().setCarte(carte);
			panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
			panneauCentral.fenetre.panneauCarte.repaint();
			if (this.panneauCentral.fenLegende == null) {
				this.panneauCentral.creerFenetreLegende(carte);
			} else {
				this.panneauCentral.fenLegende.panneauLegende.setCarte(carte);
			}
/*			if (this.panneauCentral.fen3D != null) {
				this.panneauCentral.fen3D.refresh();
			}*/
			this.panneauCentral.fenLegende.repaint();
			FenetrePrincipale.itemSupprAnalyses.setEnabled(true);
			barreOutil.bChoroplethe.setEnabled(true);
			barreOutil.bCorbeille.setEnabled(true);
			barreOutil.bEnregistrer.setEnabled(true);
			barreOutil.bSymbol.setEnabled(true);
		}
	}

	public void afficheBDSymbolique() {
		if (carte.analyseSymb.champNum != -1 && carte.getTypeAnalyse() != 2) {
			//carte.recyclage();       
			panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
		}
		BoiteDialogueSymbolique bdSymb = new BoiteDialogueSymbolique(this, true, Messages.getString("FenetrePrincipale.82"), c, t); //$NON-NLS-1$
		bdSymb.setLocationRelativeTo(this);
		bdSymb.setVisible(true);
		if (carte.analyseSymb.champNum != -1) {
			c = panneauCentral.getColumnNames();
			t = panneauCentral.getTableau();
			panneauCentral.fenetre.panneauCarte.getFondCarte().setTableauCols(t, c);
			panneauCentral.fenetre.panneauCarte.getFondCarte().setCarte(carte);
			panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
			panneauCentral.fenetre.panneauCarte.repaint();
			if (this.panneauCentral.fenLegende == null) {
				this.panneauCentral.creerFenetreLegende(carte);
			} else {
				this.panneauCentral.fenLegende.panneauLegende.setCarte(carte);
				this.panneauCentral.fenLegende.repaint();
			}
/*			if (this.panneauCentral.fen3D != null) {
				this.panneauCentral.fen3D.refresh();
			}*/
			FenetrePrincipale.itemSupprAnalyses.setEnabled(true);
			barreOutil.bSymbol.setEnabled(true);
			barreOutil.bCorbeille.setEnabled(true);
			barreOutil.bEnregistrer.setEnabled(true);
			barreOutil.bSymbol.setEnabled(true);
		}
	}

	public void afficheMiseEnPage() {
		this.panneauCentral.creerFenetreMEP(this);
	}

	public void recyclage() {
		carte.recyclage();
		if (this.panneauCentral.fenLegende != null) {
			this.panneauCentral.fenLegende.setVisible(false);
			this.panneauCentral.fenLegende.dispose();
			this.panneauCentral.fenLegende = null;
		}
		panneauCentral.fenetre.panneauCarte.getFondCarte().setParams();
		panneauCentral.fenetre.panneauCarte.repaint();
		FenetrePrincipale.itemSupprAnalyses.setEnabled(false);
		barreOutil.bCorbeille.setEnabled(false);
	}

	protected static Image createImage(String path) {
		java.net.URL imgURL = BarreOutil.class.getResource(path);
		if (imgURL != null) {
			try {
				return ImageIO.read(imgURL);
			} catch (IOException e) {
				System.out.println(Messages.getString("FenetrePrincipale.83") + imgURL); //$NON-NLS-1$
			}
		} else {
			System.err.println(Messages.getString("FenetrePrincipale.84") + path); //$NON-NLS-1$
			return null;
		}
		return null;
	}

	public static void main(String args[]) {
		FenetrePrincipale f = new FenetrePrincipale();
		f.setVisible(true);
	}

	// Variables declaration - do not modify
	public JMenuBar barreMenu;

	public BarreOutil barreOutil;

	public PanneauDroite panneauDroite;

	public FenetreMilieu panneauCentral;

	public FenetreLegende panneauLegende;

	public Arborescence arbre;

	//Menu
	public static javax.swing.JMenu mCarte;

	public static javax.swing.JMenuItem itemExportComm;

	public static javax.swing.JMenuItem itemPostscript;

	public static javax.swing.JMenuItem itemSupprFond;

	public static javax.swing.JMenuItem itemTrier;

	public static javax.swing.JMenuItem itemImprimer;

	public static javax.swing.JMenuItem itemSupprSymb;

	public static javax.swing.JMenuItem itemDeplacerSymb;

	public static javax.swing.JMenu mEnrichissements;

	public static javax.swing.JMenuItem itemImporterMIF;

	public static javax.swing.JSeparator jSeparator211;

	public static javax.swing.JMenuItem itemFermerIm;

	public static javax.swing.JSeparator jSeparator21;

	public static javax.swing.JMenuItem itemChoroHach;

	public static javax.swing.JMenuItem itemChoroCouleur;

	public static javax.swing.JMenuItem itemAffichDonneeFlux;

	public static javax.swing.JSeparator jSeparator21111;

	public static javax.swing.JMenu mImage;

	public static javax.swing.JMenuItem itemMosaV;

	public static javax.swing.JMenuItem itemEtiquetteAuto;

	public static javax.swing.JMenu itemExporter;

	public static javax.swing.JMenuItem itemOuvrirIm;

	public static javax.swing.JMenuItem itemAjoutSymb;

	public static javax.swing.JMenuItem itemSupprLib;

	public static javax.swing.JMenuItem itemSupprTousLib;

	public static javax.swing.JMenuItem itemSupprAnalyses;

	public static javax.swing.JMenuItem itemSupprTousSymb;

	public static javax.swing.JMenuItem itemSupprEch;

	public static javax.swing.JMenuItem itemAjouModifFond;

	public static javax.swing.JMenuItem itemMosaH;

	public static javax.swing.JMenuItem itemEMF;

	public javax.swing.JMenuBar menu;

	public static javax.swing.JMenuItem itemCreerChamp;

	public static javax.swing.JMenuItem itemExportD;

	public static javax.swing.JMenuItem itemAPropos;

	public static javax.swing.JMenu mFenetres;

	public static javax.swing.JMenuItem itemSymboliqueFlux;

	public static javax.swing.JMenuItem itemFermer;

	public static javax.swing.JMenuItem itemCascade;

	public static javax.swing.JMenu mAide;

	public static javax.swing.JMenu mFichier;

	public static javax.swing.JMenuItem itemBMP;

	public static javax.swing.JMenuItem itemModifAjouComm;

	public static javax.swing.JMenu mEdition;

	public static javax.swing.JMenuItem itemImportDFlux;

	public static javax.swing.JMenuItem itemCarteLissee;

	public static javax.swing.JMenu itemEchGraph;

	public static javax.swing.JSeparator jSeparator2111111;

	public static javax.swing.JMenuItem itemOuvrir;

	public static javax.swing.JMenuItem itemImportD;

	public static javax.swing.JMenuItem itemPreference;

	public static javax.swing.JMenuItem itemCopierEMF;

	public static javax.swing.JMenuItem itemSymbolique;

	public static javax.swing.JSeparator jSeparator10;

	//public javax.swing.JMenuItem itemCarte3d;

	public static javax.swing.JMenuItem itemCarteJTS;
	
	public static javax.swing.JMenu mDonnees;

	public static javax.swing.JMenuItem itemAjouLib;

	public static javax.swing.JMenuItem itemNomEtud;

	public static javax.swing.JSeparator jSeparator9;

	public static javax.swing.JSeparator jSeparator8;

	public static javax.swing.JSeparator jSeparator7;

	public static javax.swing.JSeparator jSeparator6;

	public static javax.swing.JSeparator jSeparator5;

	public static javax.swing.JSeparator jSeparator4;

	public static javax.swing.JMenuItem itemQuitter;

	public JMenuItem itemDernier;

	public static JSeparator jSeparator2211111;

	public static javax.swing.JSeparator jSeparator3;

	public static javax.swing.JMenuItem itemProj;

	public static javax.swing.JSeparator jSeparator2;

	public static javax.swing.JMenuItem itemCopierBMP;

	public static javax.swing.JMenuItem itemCentrReduc;

	public static javax.swing.JSeparator jSeparator211111;

	public static javax.swing.JMenuItem itemModifTextLib;

	public static javax.swing.JMenuItem itemUtilisation;

	public static javax.swing.JMenuItem itemCalcChamp;

	public static javax.swing.JMenuItem itemDeplacerLib;

	public static javax.swing.JMenu mCommentaires;

	public static javax.swing.JMenuItem itemEnregistrerTout;

	public static javax.swing.JMenuItem itemEnregistrer;

	public static javax.swing.JSeparator jSeparator2111;

	public static javax.swing.JMenuItem itemAjoutEch;

	public static javax.swing.JMenuItem itemSupprDFlux;

	public static javax.swing.JMenuItem itemNouveau;

	public static javax.swing.JMenuItem itemCopierD;

	public static javax.swing.JMenuItem itemSupprChamp;

	public static javax.swing.JMenuItem itemMEP;
	
	public static javax.swing.JMenuItem itemJTS;
	
	//fin Menu
	// End of variables declaration

	public FenetreMilieu getPanneauCentral() {
		return panneauCentral;
	}

	public void setPanneauCentral(FenetreMilieu panneauCentral) {
		this.panneauCentral = panneauCentral;
	}

	public Carte getCarte() {
		return carte;
	}

	public void setCarte(Carte carte) {
		this.carte = carte;
	}
}