/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author Laurent
 * Fonction : Boéte de dialogue pour ajouter un texte et le formater (MEP)
 */

public class FontChooser extends JPanel {

    private javax.swing.JComboBox fcjcFontes;

    private javax.swing.JButton fcjbItalique;

    private javax.swing.JButton fcjbGras;

    private javax.swing.JLabel fcjlExemple;

    private javax.swing.JComboBox fcjcTailles;

    private JButton fcjbCouleur;
    
    private JLabel fcjlIndication;

    //private javax.swing.JButton JBOk;

    private boolean init;

    private Font aFonte;
    
    private String estGras = "-"; //$NON-NLS-1$
    
    private String estItalique = "-"; //$NON-NLS-1$
    
    private DesignSurface base;

    public FontChooser(Frame fp, DesignSurface base, Font aFonte) {
        //super(fp, "Choix de la fonte", true);
        super();
        this.aFonte = aFonte;
        this.base = base;
        initComponents();
    }
    
    private void initComponents() {
        int i = 0;

        fcjcFontes = new javax.swing.JComboBox();
        fcjcTailles = new javax.swing.JComboBox();
        fcjlExemple = new javax.swing.JLabel();
        fcjbGras = new javax.swing.JButton();
        fcjbItalique = new javax.swing.JButton();
        fcjbCouleur = new javax.swing.JButton();
        fcjlIndication = new javax.swing.JLabel();
        //JBOk = new javax.swing.JButton();

        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        fcjcFontes.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        fcjcFontes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FCFontesActionPerformed(evt);
            }
        });
        Font[] fontes = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
        this.init = true;
        for (i = 0; i < fontes.length; i++) {
            fcjcFontes.addItem(fontes[i].getFontName());
        }
        this.init = false;

        add(fcjcFontes, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 8, 276, -1));

        fcjcTailles.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        fcjcTailles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FCtaillesActionPerformed(evt);
            }
        });
        this.init = true;
        for (i = 6; i <= 48; i++) {
            fcjcTailles.addItem("" + i); //$NON-NLS-1$
        }
        this.init = false;
        
        add(fcjcTailles, new org.netbeans.lib.awtextra.AbsoluteConstraints(286, 8, 60, -1));

        fcjlExemple.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        fcjlExemple.setBorder(BorderFactory.createLineBorder(Color.black));
        add(fcjlExemple, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 40, 462, 40));

        fcjbGras.setFont(new java.awt.Font("Courier New", 1, 12)); //$NON-NLS-1$
        fcjbGras.setText("G"); //$NON-NLS-1$
        fcjbGras.setMargin(new java.awt.Insets(2, 2, 2, 2));
        fcjbGras.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                grasActionPerformed();
            }
        });
        
        add(fcjbGras, new org.netbeans.lib.awtextra.AbsoluteConstraints(354, 7, 24, -1));

        fcjbItalique.setFont(new java.awt.Font("Courier New", 2, 12)); //$NON-NLS-1$
        fcjbItalique.setText("i"); //$NON-NLS-1$
        fcjbItalique.setMargin(new java.awt.Insets(2, 2, 2, 2));
        fcjbItalique.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                italiqueActionPerformed();
            }
        });
        add(fcjbItalique, new org.netbeans.lib.awtextra.AbsoluteConstraints(384, 7, 24, -1));

        fcjbCouleur.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        fcjbCouleur.setText("Couleur"); //$NON-NLS-1$
        fcjbCouleur.setMargin(new java.awt.Insets(2, 2, 2, 2));
        fcjbCouleur.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbCouleurActionPerformed(evt);
            }
        });

        add(fcjbCouleur, new org.netbeans.lib.awtextra.AbsoluteConstraints(414, 7, 54, -1));

        fcjlIndication.setFont(new java.awt.Font("Microsoft Sans Serif", 3, 12)); //$NON-NLS-1$
        fcjlIndication.setText(Messages.getString("FontChooser.0"));         //$NON-NLS-1$
        add(fcjlIndication, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 80, 90, 20));
        
        fcjcFontes.setSelectedItem(aFonte.getFontName());
        fcjcTailles.setSelectedItem(String.valueOf(aFonte.getSize()));

    }

    private void FCFontesActionPerformed(java.awt.event.ActionEvent evt) {
        if (this.init == false) {
            fcjlExemple.setFont(Font.decode(fcjcFontes.getSelectedItem().toString() + "-" + fcjcTailles.getSelectedItem().toString())); //$NON-NLS-1$
            fcjlExemple.setText(fcjlExemple.getFont().getFontName());
            base.setAFonte(fcjlExemple.getFont());
            this.repaint();
        }
    }

    private void FCtaillesActionPerformed(java.awt.event.ActionEvent evt) {
            fcjlExemple.setFont(Font.decode(fcjcFontes.getSelectedItem().toString() + "-" + fcjcTailles.getSelectedItem().toString())); //$NON-NLS-1$
            fcjlExemple.setText(fcjlExemple.getFont().getFontName());
            base.setAFonte(fcjlExemple.getFont());
            this.repaint();
    }

    private void jbCouleurActionPerformed(java.awt.event.ActionEvent evt) {
        Color newColor = JColorChooser.showDialog(this, Messages.getString("FontChooser.16"), base.getAColor()); //$NON-NLS-1$
        if (newColor != null) base.setAColor(newColor);
        fcjlExemple.setForeground(base.getAColor());
        this.repaint();
    }
    
    private void grasActionPerformed() {
        if ((base.getAFonte().getStyle() & Font.BOLD) == 1) { //$NON-NLS-1$
        	base.setAFonte(base.getAFonte().deriveFont(base.getAFonte().getStyle() ^ Font.BOLD));
        } else {
        	base.setAFonte(base.getAFonte().deriveFont(base.getAFonte().getStyle() | Font.BOLD));
        }
	    fcjlExemple.setFont(base.getAFonte());	
        fcjlExemple.setText(fcjlExemple.getFont().getFontName());
		//base.setAFonte(fcjlExemple.getFont());
	    this.repaint();
    }

    private void italiqueActionPerformed() {
        if ((base.getAFonte().getStyle() & Font.ITALIC) == 2) { //$NON-NLS-1$
        	base.setAFonte(base.getAFonte().deriveFont(base.getAFonte().getStyle() ^ Font.ITALIC));
        } else {
        	base.setAFonte(base.getAFonte().deriveFont(base.getAFonte().getStyle() | Font.ITALIC));
        }
	    fcjlExemple.setFont(base.getAFonte());
	    fcjlExemple.setText(fcjlExemple.getFont().getFontName());
	    //base.setAFonte(fcjlExemple.getFont());
        this.repaint();
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {

    }

}