/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;

import javax.swing.JPanel;

import carto.AnalyseSymboles;
import carto.Carte;

/**
 * @author Laurent
 *  
 */

public class PanneauSymbole extends JPanel {

    private Carte carte;

    private boolean typeValeurs; //true = valeurs positives.

    private BoiteDialogueSymbolique base;

    public boolean isTypeValeurs() {
        return typeValeurs;
    }

    public void setTypeValeurs(boolean typeValeurs) {
        this.typeValeurs = typeValeurs;
    }

    public PanneauSymbole(BoiteDialogueSymbolique parent, Carte carte) {
        super();
        this.base = parent;
        this.carte = carte;
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        AnalyseSymboles analyse = carte.analyseSymb;
        int mx = (int) (this.getWidth() / 2);
        int my = (int) (this.getHeight() / 2);
        Color cSurface;
        Color cContour;
        Color tColor;
        typeValeurs = base.jrbCVPos.isSelected();
        if (typeValeurs) {
            //Valeurs positives
            cSurface = analyse.couleurSymbole;
            cContour = analyse.couleurContour;
        } else {
            //Valeurs négatives
            cSurface = analyse.couleurSymboleNeg;
            cContour = analyse.couleurContourNeg;
        }
        tColor = new Color(cSurface.getRed(), cSurface.getGreen(), cSurface.getBlue(), (int)(analyse.opacite * 255));
        Stroke normalStroke = g2.getStroke();
        switch (analyse.typeSymbole) {
        case 0: //Cercles
            int rayon = (int) (Math.sqrt(analyse.surfRef / 4));
            int diametre = rayon * 2;
            g2.setStroke(new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL));
            g2.setPaint(tColor);
            g2.fillOval(mx - rayon, my - rayon, diametre, diametre);
            g2.setPaint(cContour);
            g2.drawOval(mx - rayon, my - rayon, diametre, diametre);
            g2.setStroke(normalStroke);
            break;
        case 1: //Carres
            int demicote = (int) (Math.sqrt(analyse.surfRef) / 2);
            int cote = demicote * 2;
            g2.setStroke(new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL));
            g2.setPaint(tColor);
            g2.fillRect(mx - demicote, my - demicote, cote, cote);
            g2.setPaint(cContour);
            g2.drawRect(mx - demicote, my - demicote, cote, cote);
            g2.setStroke(normalStroke);
            break;
        }
    }

}