package guiInterface;

import java.awt.color.ColorSpace;

public class cs_quadri extends ColorSpace {
	  static final ColorSpace cs_RGB = getInstance(ColorSpace.CS_sRGB);
	  static cs_quadri m_instance = null;
	  
	public cs_quadri() {
		super(ColorSpace.TYPE_CMYK, 4);
	}

    public static cs_quadri getInstance() {
		if (m_instance == null) m_instance = new cs_quadri();
		return m_instance;
    }

	public float[] toRGB(float[] colorvalue) {
		float[] rgb = new float[] {0, 0, 0};
		float k = colorvalue[3];
		rgb[0] = 1.0f - Math.min(1.0f, colorvalue[0] + k);
		rgb[1] = 1.0f - Math.min(1.0f, colorvalue[1] + k);
		rgb[2] = 1.0f - Math.min(1.0f, colorvalue[2] + k);

		return rgb;
	}

	public float[] fromRGB(float[] rgbvalue) {
		float[] cmjn = new float[4];
		float c = 1.0f - rgbvalue[0];
		float m = 1.0f - rgbvalue[1];
		float y = 1.0f - rgbvalue[2];
		float k = Math.min(Math.min(c,m), y);

		cmjn[0] = c - k; cmjn[1] = m - k; cmjn[2] = y - k; cmjn[3] = k;
		return cmjn;
	}


    public float[] fromCIEXYZ(float[] colorvalue) {
		return fromRGB(cs_RGB.fromCIEXYZ(colorvalue));
	}

	public float[] toCIEXYZ(float[] colorvalue) {
		return cs_RGB.toCIEXYZ(toRGB(colorvalue));
	}

}
